/*
 * Main.java
 *
 * Created on 19 janvier 2004, 23:11
 */

package simulations;

import java.util.ArrayList;

/** This is the main class (with main method).
 * @author tom
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
        
    }
    
    /** main() method. Launch the main frame of the program.
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        if (args.length==0) {
            new Main().printUsage();
            System.exit(0);
        }
        if (args[0].equals("-gui")) {
            if (args.length>=2) {
                if (args[1].equals("-debug")) {
                    SimulationParameters.debug=true;
                } else {
                    SimulationParameters.debug=false;
                }
            } else {
                SimulationParameters.debug=false;
            }
            simulations.gui.MainFrame frame = new simulations.gui.MainFrame();
            frame.setVisible(true);
        } else {
            boolean coalSave = false;
            simulations.xml.DocumentTracer parser = new simulations.xml.DocumentTracer(args[0]);
            simulations.xml.DataChecker checker = new simulations.xml.DataChecker();
            if (!(checker.checkName((ArrayList)parser.getPlayerList().clone()))) {
                System.out.println("All player's names must be different!");
                System.exit(0);
            }
            boolean noSave=false;
            if (args.length>=2) {
                if (args[1].equals("-debug")) {
                    SimulationParameters.debug=true;
                } else {
                    SimulationParameters.debug=false;
                }
                if (args[1].equals("-noHistory")) {
                    noSave=true;
                } else {
                    noSave=false;
                }
                if (args[1].equals("-coal")) {
                    coalSave = true;
                }
            } else {
                SimulationParameters.debug=false;
            }
            if (args.length>=3) {
                if (args[2].equals("-debug")) {
                    SimulationParameters.debug=true;
                } else {
                    SimulationParameters.debug=false;
                }
                if (args[2].equals("-noHistory")) {
                    noSave=true;
                } else {
                    noSave=false;
                }
                if (args[2].equals("-coal")) {
                    coalSave = true;
                }
            }
            if (args.length>=3) {
                if (args[2].equals("-debug")) {
                    SimulationParameters.debug=true;
                } else {
                    SimulationParameters.debug=false;
                }
                if (args[2].equals("-noHistory")) {
                    noSave=true;
                } else {
                    noSave=false;
                }
                if (args[2].equals("-coal")) {
                    coalSave = true;
                }
            }
            new simulations.core.Judge(new simulations.core.Game(
                parser.getPlayerList(), parser.getSeed(),parser.getLoosingPoints(),parser.getWinnerPoints(),
                parser.getCoalitionPoints(),parser.isProportional(),parser.getTraceLevel(),parser.getHistoryFile(),
                parser.getGraphFile(),parser.getCoalitionDefinition(),noSave,coalSave)).playGame();
            System.exit(0);
        }
    }
    
    /** print the usage of the program to the screen **/
    private void printUsage() {
        System.out.println("java -jar simulations.jar [-gui]|[xmlFile] [-debug] [-noHistory] [-coal]");
    }
    
}
