/*
 * Player.java
 *
 * Created on 20 janvier 2004, 15:39
 */

package simulations.core;

import simulations.core.strategy.completeStrategy.CompleteStrategy;

import java.util.ArrayList;

/** This class describes a player of the game.
 * @author tom
 */
public class Player implements java.lang.Cloneable {
    
    /** The player's name **/
    private String name;
    
    /** The hit points of the player **/
    private float hitPoints;
    
    /** The player's strategy**/
    private CompleteStrategy strategy;
    
    /** Creates a new instance of Player
     * @param name The name of the player.
     * @param hitPoints The hit points of the player.
     * @param strategy The strategy of the player.
     */
    public Player(String name, float hitPoints, CompleteStrategy strategy) {
        this.name=name;
        this.hitPoints=hitPoints;
        this.strategy=strategy;
    }
    
    /** Second constructor
     * @param name The name of the player.
     * @param hitPoints The HP of the player.
     */    
    public Player(String name, int hitPoints) {
        this.name=name;
        this.hitPoints=hitPoints;
    }
    
    /** overload of toString() method.
     * @return The name of the player.
     */    
    public String toString() {
        return name;
    }
    
    /** Getter for property hitPoints.
     * @return Value of property hitPoints.
     *
     */
    public float getHitPoints() {
        return hitPoints;
    }
    
    /** Setter for property hitPoints.
     * @param hitPoints New value of property hitPoints.
     *
     */
    public void setHitPoints(float hitPoints) {
        this.hitPoints = hitPoints;
    }
    
    /** Getter for property name.
     * @return Value of property name.
     *
     */
    public java.lang.String getName() {
        return name;
    }
    
    /** Setter for property name.
     * @param name New value of property name.
     *
     */
    public void setName(java.lang.String name) {
        this.name = name;
    }
    
    /** Getter for property strategy.
     * @return Value of property strategy.
     *
     */
    public simulations.core.strategy.completeStrategy.CompleteStrategy getStrategy() {
        return strategy;
    }
    
    /** Setter for property strategy.
     * @param strategy New value of property strategy.
     *
     */
    public void setStrategy(simulations.core.strategy.completeStrategy.CompleteStrategy strategy) {
        this.strategy = strategy;
    }
    
    /** Returns the clone of the player
     * @return Returns the clone of the player
     */    
    public Object clone() {
        return new Player(name,hitPoints, strategy);
    }
    
    /** overload of equals() method.
     * @param o The object to compare.
     * @return true if the object is equals to the parameter.
     */    
    public boolean equals(Object o) {
        if (o instanceof Player) {
            Player p = (Player)o;
            if (name.equals(p.getName())) {
                return true;
            }
        }
        return false;
    }
    
    /** A second method to compare Players
     * Return true if the players have same name and HP
     * @param o The object to compare.
     * @return true if the object is equals to the parameter.
     */    
    public boolean equals2(Object o) {
        if (o instanceof Player) {
            Player p = (Player)o;
            if ((name.equals(p.getName()))&&(hitPoints==p.getHitPoints())) {
                return true;
            }
        }
        return false;
    }
    
}
