/*
 * PlayerTurn.java
 *
 * Created on March 20, 2004, 9:59 PM
 */

package simulations.core.history;

import simulations.core.Player;

import java.util.ArrayList;
import java.util.Iterator;

/** This class describes a player's turn
 * @author tom
 */
public class PlayerTurn implements Cloneable {
    
    private Player player;
    
    private Player attackedPlayer;
    
    /** The list of the players who accept to help **/
    private ArrayList playersAcceptingSupport;
    
    /** The list of the players who refuse to help **/
    private ArrayList playersRefusingSupport;
    
    /** True if the attack was a succes false otherwise **/
    private boolean success;
    
    /** Creates a new instance of PlayerTurn
     * @param success True if the attack was a success false otherwise
     * @param player The attacking player
     * @param attackedPlayer The attacked player
     * @param playersAcceptingSupport The list of players accepting to help the attack
     * @param playersRefusingSupport The list of players refusing to help the attack
     */
    public PlayerTurn(Player player, Player attackedPlayer, ArrayList playersAcceptingSupport,
    ArrayList playersRefusingSupport, boolean success) {
        this.player=player;
        this.attackedPlayer=attackedPlayer;
        this.playersAcceptingSupport=playersAcceptingSupport;
        this.playersRefusingSupport=playersRefusingSupport;
        this.success=success;
        ArrayList l = (ArrayList)playersAcceptingSupport.clone();
    }
    
    /** overide of the equals method
     * @param o The object to compare
     * @return true if the object are equal
     */    
    public boolean equals(Object o) {
        if (simulations.SimulationParameters.debug) {
            System.out.println("equals playerTurn");
        }
        if (o instanceof PlayerTurn) {
            //System.out.println("1");
            PlayerTurn pt = (PlayerTurn)o;
            if (player.getHitPoints()!=pt.getPlayer().getHitPoints()) {
                if (simulations.SimulationParameters.debug) {
                    System.out.println("false car points differents");
                }
                return false;
            }
            //System.out.println("2");
            if (!(attackedPlayer.equals(pt.getAttackedPlayer()))) {
                if (simulations.SimulationParameters.debug) {
                    System.out.println("false car player attaque differents");
                }
                return false;
            }
            //System.out.println("3");
            if (!(success==pt.isSuccess())) {
                if (simulations.SimulationParameters.debug) {
                    System.out.println("False car succes differents");
                }
                return false;
            }
            //System.out.println("4");
            // construct the list of asks
            ArrayList l1 = new ArrayList();
            //System.out.println("5");
            //System.out.println("playersAcceptingSupport.size() = "+playersAcceptingSupport.size());
            for(int i=0;i<playersAcceptingSupport.size();i++) {
                Player p = (Player)playersAcceptingSupport.get(i);
                l1.add((Player)p.clone());
            }
            //System.out.println("6");
            //System.out.println("1 : accepting : "+this.getPlayersAcceptingSupport().toString());
            //System.out.println("1 : refusing : "+this.getPlayersRefusingSupport().toString());
            for(int i=0;i<playersRefusingSupport.size();i++) {
                Player p = (Player)playersRefusingSupport.get(i);
                l1.add((Player)p.clone());
            }
            //System.out.println("7");
            ArrayList l2 = new ArrayList();
            //System.out.println("2 : accepting : "+pt.getPlayersAcceptingSupport().toString());
            //System.out.println("2 : refusing : "+pt.getPlayersRefusingSupport().toString());
            //System.out.println("8");
            for(int i=0;i<pt.getPlayersAcceptingSupport().size();i++) {
                Player p = (Player)pt.getPlayersAcceptingSupport().get(i);
                l2.add((Player)p.clone());
            }
            //System.out.println("9");
            for(int i=0;i<pt.getPlayersRefusingSupport().size();i++) {
                Player p = (Player)pt.getPlayersRefusingSupport().get(i);
                l2.add((Player)p.clone());
            }
            //System.out.println("10");
            //System.out.println(l1.toString());
            //System.out.println(l2.toString());
            if (!(l1.size()==l2.size())) {
                if (simulations.SimulationParameters.debug) {
                    System.out.println("false car taille liste soutien diff?rents");
                }
                return false;
            }
            //System.out.println("11");
            if (!(l1.containsAll(l2))) {
                if (simulations.SimulationParameters.debug) {
                    System.out.println("false car liste soutien diff?rents");
                }
                return false;
            }
            //System.out.println("12");
            if (simulations.SimulationParameters.debug) {
                System.out.println("equals playerTurn true");
            }
            return true;
        }
        return false;
    }
    
    /** Overload of toString() method
     * @return The player of the playerTurn
     **/
    public String toString() {
        return player.toString();
    }
    
    /** Constructor */    
    public PlayerTurn() {
        playersAcceptingSupport=new ArrayList();
        playersRefusingSupport=new ArrayList();
    }
    
    /** Print the player turn */    
    public void print() {
        String s;
        s=player.toString()+" decided to attack "+attackedPlayer.toString()+"\n";
        s=s.concat("He ask support to : \n");
        Iterator it = playersAcceptingSupport.iterator();
        while (it.hasNext()) {
            Player p = (Player)it.next();
            s=s.concat((p.toString()+" (Accepted)\n"));
        }
        it = playersRefusingSupport.iterator();
        while (it.hasNext()) {
            Player p = (Player)it.next();
            s=s.concat((p.toString()+" (Refused)\n"));
        }
        System.out.println(s);
    }
    
    /** Getter for property attackedPlayer.
     * @return Value of property attackedPlayer.
     *
     */
    public simulations.core.Player getAttackedPlayer() {
        return attackedPlayer;
    }
    
    /** Setter for property attackedPlayer.
     * @param attackedPlayer New value of property attackedPlayer.
     *
     */
    public void setAttackedPlayer(simulations.core.Player attackedPlayer) {
        this.attackedPlayer = attackedPlayer;
    }
    
    /** Getter for property player.
     * @return Value of property player.
     *
     */
    public simulations.core.Player getPlayer() {
        return player;
    }
    
    /** Setter for property player.
     * @param player New value of property player.
     *
     */
    public void setPlayer(simulations.core.Player player) {
        this.player = player;
    }
    
    /** Getter for property playersAcceptingSupport.
     * @return Value of property playersAcceptingSupport.
     *
     */
    public java.util.ArrayList getPlayersAcceptingSupport() {
        return playersAcceptingSupport;
    }
    
    /** Setter for property playersAcceptingSupport.
     * @param playersAcceptingSupport New value of property playersAcceptingSupport.
     *
     */
    public void setPlayersAcceptingSupport(java.util.ArrayList playersAcceptingSupport) {
        this.playersAcceptingSupport = playersAcceptingSupport;
    }
    
    /** Getter for property playersRefusingSupport.
     * @return Value of property playersRefusingSupport.
     *
     */
    public java.util.ArrayList getPlayersRefusingSupport() {
        return playersRefusingSupport;
    }
    
    /** Setter for property playersRefusingSupport.
     * @param playersRefusingSupport New value of property playersRefusingSupport.
     *
     */
    public void setPlayersRefusingSupport(java.util.ArrayList playersRefusingSupport) {
        this.playersRefusingSupport = playersRefusingSupport;
    }
    
    /** This method returns a clone of PlayerTurn
     * @return returns a clone of PlayerTurn
     */    
    public PlayerTurn getClone() {
        try {
            return (PlayerTurn)this.clone();
        }catch(CloneNotSupportedException e) {
            return null;
        }
    }
    
    /** Getter for property success.
     * @return Value of property success.
     *
     */
    public boolean isSuccess() {
        return success;
    }
    
    /** Setter for property success.
     * @param success New value of property success.
     *
     */
    public void setSuccess(boolean success) {
        this.success = success;
    }
    
}
