/*
 * Turn.java
 *
 * Created on March 20, 2004, 9:58 PM
 */

package simulations.core.history;

import simulations.core.Player;

import java.util.ArrayList;
import java.util.Iterator;

/**
 * Contains a list (n elt) of player's turn
 * @author  tom
 */
public class Turn extends java.lang.Object implements java.lang.Cloneable {
    
    /** The players turn list **/
    private ArrayList playersTurnsList;
    
    /** Creates a new instance of Turn
     * @param playersTurnsList The player's turn list
     */
    public Turn(ArrayList playersTurnsList) {
        this.playersTurnsList=playersTurnsList;
    }
    
    /** Constructor */    
    public Turn() {
        playersTurnsList=new ArrayList();
    }
    
    /** Add the player turn in the turn
     * @param playerTurn The player turn to add
     */    
    public void add(PlayerTurn playerTurn) {
        playersTurnsList.add(playerTurn);
    }
    
    /** Getter for property playersTurnsList.
     * @return Value of property playersTurnsList.
     *
     */
    public java.util.ArrayList getPlayersTurnsList() {
        return playersTurnsList;
    }
    
    /** Setter for property playersTurnsList.
     * @param playersTurnsList New value of property playersTurnsList.
     *
     */
    public void setPlayersTurnsList(java.util.ArrayList playersTurnsList) {
        this.playersTurnsList = playersTurnsList;
    }
    
    /** Print the turn */    
    public void print() {
        System.out.println(playersTurnsList.size()+" entrees");
        for(int i=0;i<playersTurnsList.size();i++) {
            PlayerTurn pt = (PlayerTurn)playersTurnsList.get(i);
            System.out.println("pt "+i+" : "+pt.getPlayer().toString()+" vs "+pt.getAttackedPlayer().toString());
            System.out.println("Accept : "+pt.getPlayersAcceptingSupport().toString());
            System.out.println("Refus : "+pt.getPlayersRefusingSupport().toString());
        }
    }
    
    /** overide of the equals method
     * @param o The object to compare
     * @return true if the two object are equal
     */    
    public boolean equals(Object o) {
        if (simulations.SimulationParameters.debug) {
            System.out.println("equals turn");
        }
        //System.out.println("equalsTurn");
        if (o instanceof Turn) {
            Turn t = (Turn)o;
            // means that a player loose in last turn
            if (playersTurnsList.size()!=t.getPlayersTurnsList().size()) {
                //System.out.println("False car ptl taille differents");
                return false;
            }
            for(int i=0;i<playersTurnsList.size();i++) {
                PlayerTurn pt = (PlayerTurn)playersTurnsList.get(i);
                PlayerTurn pt2 = (PlayerTurn)t.getPlayersTurnsList().get(i);
                if (!(pt.equals(pt2))) {
                    return false;
                }
            }
            if (simulations.SimulationParameters.debug) {
                System.out.println("equals turn true");
            }
            return true;
        }
        return false;
    }
    
    /** This method returns a clone of Turn
     * @return returns a clone of Turn
     */    
    public Turn getClone() {
        try {
            return (Turn)this.clone();
        }catch(CloneNotSupportedException e) {
            return null;
        }
    }
}
