/*
 * AskingEveryoneStrategy.java
 *
 * Created on April 9, 2004, 2:42 AM
 */

package simulations.core.strategy.askingSupportStrategy;

import simulations.core.Player;
import java.util.ArrayList;
import java.util.Iterator;
import simulations.core.history.Turn;

/** This class describes an asking strategy that aking help to everyone
 * @author tom
 */
public class AskingEveryoneStrategy extends AskingStrategy {
    
    /** Creates a new instance of AskingEveryoneStrategy */
    public AskingEveryoneStrategy() {
        super();
        name="AskingEveryoneStrategy";
        memoryParam=false;
        abr="1";
    }
        
    /** Returns the list of players to ask support.
     * @return Returns the list of players to ask support.
     * @param attackedPlayer The attacked player
     * @param player The attacking player
     * @param playerList The list of <B>avalaible</B> player
     */    
    public java.util.ArrayList getPlayersToAskSupport(simulations.core.Player player, simulations.core.Player attackedPlayer, java.util.ArrayList playerList) {
        if (negative) {
            return new ArrayList();
        } else {
            playerList.remove(player);
            return playerList;
        }
    }
    
    /** This method is called by the judge to inform players of the last turn
     * @param turn The turn
     * @param player The owner of the strategy
     * @param remainingPlayers The list of the remaining players
     */    
    public void updateLastTurn(simulations.core.history.Turn turn, Player player, ArrayList remainingPlayers) {
    }
    
    /** This method returns the description of the strategy
     * @return returns the description of the strategy
     */    
    public String getDescription() {
        if (negative) {
            return "Asking support strategy :\n"+
            "I ask support to everybody\n"+
            "COMPLEMENTARY";
        } else {
            return "Asking support strategy :\n"+
            "I ask support to everybody\n";
        }
    }
    
}
