/*
 * AdvancedCoalitionalDef4Strategy.java
 *
 * Created on 24 juin 2004, 23:57
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.SpitefulAttackStrategy2;
import simulations.core.strategy.attackStrategy.AttackWeakestStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.CoalitionalDef4AttackStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.CoalitionalDef4AskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.CoalitionalDef4DecisionStrategy;


/**
 *
 * @author  tom
 */
public class AdvancedCoalitionalDef4Strategy extends GenericComposedStrategy {
    
    /** Creates a new instance of AdvancedCoalitionalDef4Strategy */
    public AdvancedCoalitionalDef4Strategy() {
        super();
        name="AdvancedCoalitionalDef4Strategy";
        attackStrategyVector.addElement(new CoalitionalDef4AttackStrategy());
        AttackStrategy attStrat = new SpitefulAttackStrategy2();
        attStrat.setMemory(5);
        attackStrategyVector.addElement(attStrat);
        AttackStrategy attStrat2 = new AttackWeakestStrategy();
        attStrat2.setMemory(5);
        attackStrategyVector.addElement(attStrat2);
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new CoalitionalDef4AskingStrategy());
        decisionStrategyVector.addElement(new CoalitionalDef4DecisionStrategy());
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
    
}
