/*
 * BadStrategy.java
 *
 * Created on 24 juin 2004, 23:12
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.AttackWeakestThanMeStrategy;
import simulations.core.strategy.attackStrategy.AttackWeakestStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrongestThanMeStrategy;
import simulations.core.strategy.askingSupportStrategy.RandomAskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.RandomSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.AcceptAttackedPlayersWeakestThanMeStrategy;

/**
 *
 * @author  tom
 */
public class BadStrategy extends GenericComposedStrategy {
    
    /** Creates a new instance of BadStrategy */
    public BadStrategy() {
        super();
        name="BadStrategy";
        attackStrategyVector.addElement(new AttackWeakestThanMeStrategy());
        attackStrategyVector.addElement(new AttackWeakestStrategy());
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new AskingStrongestThanMeStrategy());
        decisionStrategyVector.addElement(new AcceptAttackedPlayersWeakestThanMeStrategy());
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
}
