/*
 * PersistentStrategyMemory0.java
 *
 * Created on 24 juin 2004, 22:50
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.AttackAttackedPlayersStrategy;
import simulations.core.strategy.attackStrategy.AttackTheMostAttackedPlayerStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingEveryoneStrategy;
import simulations.core.strategy.askingSupportStrategy.RandomAskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.RandomSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.AcceptPlayersDontAttackMeStrategy;

/**
 *
 * @author  tom
 */
public class PersistentStrategyMemory0 extends GenericComposedStrategy {
    
    /** Creates a new instance of PersistentStrategyMemory0 */
    public PersistentStrategyMemory0() {
        super();
        name="PersistentStrategyMemory0";
        AttackStrategy attStrat = new AttackAttackedPlayersStrategy();
        attStrat.setMemory(0);
        attackStrategyVector.addElement(attStrat);
        AttackStrategy attStrat2 = new AttackTheMostAttackedPlayerStrategy();
        attStrat.setMemory(0);
        attackStrategyVector.addElement(attStrat2);
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new AskingEveryoneStrategy());
        DecisionSupportStrategy decStrat = new AcceptPlayersDontAttackMeStrategy();
        decStrat.setMemory(0);
        decisionStrategyVector.addElement(decStrat);
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
}
