/*
 * SimpleCoalitionalDef2Strategy.java
 *
 * Created on 24 juin 2004, 23:40
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.CoalitionalDef2AttackStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.CoalitionalDef2AskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.CoalitionalDef2DecisionStrategy;

/**
 *
 * @author  tom
 */
public class SimpleCoalitionalDef2Strategy extends GenericComposedStrategy {
    
    /** Creates a new instance of SimpleCoalitionalDef2Strategy */
    public SimpleCoalitionalDef2Strategy() {
        super();
        name="SimpleCoalitionalDef2Strategy";
        attackStrategyVector.addElement(new CoalitionalDef2AttackStrategy());
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new CoalitionalDef2AskingStrategy());
        decisionStrategyVector.addElement(new CoalitionalDef2DecisionStrategy());
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
}
