/*
 * SimpleCoalitionalDef3Strategy.java
 *
 * Created on 24 juin 2004, 23:42
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.CoalitionalDef3AttackStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.CoalitionalDef3AskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.CoalitionalDef3DecisionStrategy;

/**
 *
 * @author  tom
 */
public class SimpleCoalitionalDef3Strategy extends GenericComposedStrategy {
    
    /** Creates a new instance of SimpleCoalitionalDef3Strategy */
    public SimpleCoalitionalDef3Strategy() {
        super();
        name="SimpleCoalitionalDef3Strategy";
        attackStrategyVector.addElement(new CoalitionalDef3AttackStrategy());
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new CoalitionalDef3AskingStrategy());
        decisionStrategyVector.addElement(new CoalitionalDef3DecisionStrategy());
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
    
}
