/*
 * StupidStrategy.java
 *
 * Created on 24 juin 2004, 19:10
 */

package simulations.core.strategy.completeStrategy;

import java.util.Random;
import java.util.ArrayList;

import simulations.core.Player;
import simulations.core.history.Turn;

import simulations.core.strategy.attackStrategy.AttackStrategy;
import simulations.core.strategy.attackStrategy.AttackRandomlyStrategy;
import simulations.core.strategy.attackStrategy.AttackStrongestStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingStrategy;
import simulations.core.strategy.askingSupportStrategy.AskingNoBodyStrategy;
import simulations.core.strategy.askingSupportStrategy.RandomAskingStrategy;
import simulations.core.strategy.decisionSupportStrategy.RandomSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.DecisionSupportStrategy;
import simulations.core.strategy.decisionSupportStrategy.NeverAcceptToSupportStrategy;

/**
 *
 * @author  tom
 */
public class StupidStrategy extends GenericComposedStrategy {
    
    /** Creates a new instance of StupidStrategy */
    public StupidStrategy() {
        super();
        name="StupidStrategy";
        attackStrategyVector.addElement(new AttackStrongestStrategy());
        attackStrategyVector.addElement(new AttackRandomlyStrategy());
        askingStrategyVector.addElement(new AskingNoBodyStrategy());
        decisionStrategyVector.addElement(new NeverAcceptToSupportStrategy());
    }

    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     */
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
    
}
