/*
 * AlwaysAcceptToSupportStrategy.java
 *
 * Created on April 9, 2004, 2:46 AM
 */

package simulations.core.strategy.decisionSupportStrategy;

import simulations.core.Player;
import java.util.ArrayList;
import java.util.Iterator;

import simulations.core.history.Turn;

/** This class describes a decision support strategy that always accept to support
 * attack
 * @author tom
 */
public class AlwaysAcceptToSupportStrategy extends DecisionSupportStrategy {
    
    /** Creates a new instance of AlwaysAcceptToSupportStrategy */
    public AlwaysAcceptToSupportStrategy() {
        super();
        name="AlwaysAcceptToSupportStrategy";
        memoryParam=false;
        abr="9";
    }
    
    /** return true if the player will support the attack.
     * @return return true if the player will support the attack.
     * @param player The owner of the strategy
     * @param attackingPlayer The attacking player
     * @param attackedPlayer The attacked player
     * @param playerList The list of remaining players
     */    
    public boolean supportAttack(Player player, Player attackingPlayer, Player attackedPlayer, ArrayList playerList) {
        if (attackedPlayer.equals(player)) {
            return false;
        }
        if (negative) {
            return false;
        } else {
            return true;
        }
    }
    
    /** This method is called by the judge to inform players of the last turn
     * @param turn The turn
     * @param player The owner of the strategy
     * @param remainingPlayers The list of the remaining players
     */    
    public void updateLastTurn(Turn turn, Player player, ArrayList remainingPlayers) {
    }
    
    /**
     * This method is called by the judge after the decision of players to attack and to ask supports
     * to inform the strategy
     * @param player The owner of the strategy
     * @param attacksList The list of attacks
     **/
    public void updateAttacksInfos(Player player, ArrayList attacksList) {
    }
    
    /** return the description of this decision support strategy
     * @return return the description of this decision support strategy
     **/
    public String getDescription() {
        return "Support decision strategy :\n"+
        "I always accept to help attack except versus myself\n";
    }
    
}
