/*
 * ViewAverageResultDialog.java
 *
 * Created on 8 juin 2004, 01:44
 */

package simulations.database.gui;

import simulations.database.core.Communication;
import simulations.database.core.Test;
import simulations.database.core.Exp;
import simulations.database.core.Serie;
import simulations.database.core.Game;
import simulations.database.core.PlayersRanking;
import simulations.database.core.Player;
import simulations.database.core.Querys;

import java.util.ArrayList;
import java.util.Vector;
import java.util.Iterator;
import java.util.HashMap;
import java.util.Map.Entry;

import javax.swing.JTable;

/**
 *
 * @author  tom
 */
public class ViewAverageResultDialog extends javax.swing.JDialog {
    
    private Querys querys;
    
    private Test selectedTest;
    
    private Exp selectedExp;
    
    private Serie selectedSerie;
    
    private Game selectedGame;
    
    private ArrayList gameList;
    
    /** Creates new form ViewAverageResultDialog */
    public ViewAverageResultDialog(java.awt.Frame parent, boolean modal, Querys querys) {
        super(parent, modal);
        this.querys=querys;
        gameList = new ArrayList();
        initComponents();
        init();
    }
    
    private void init() {
        ArrayList l = querys.getAllTests();
        testJList.setListData(l.toArray());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        closeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        testJList = new javax.swing.JList();
        jScrollPane2 = new javax.swing.JScrollPane();
        expJList = new javax.swing.JList();
        jScrollPane3 = new javax.swing.JScrollPane();
        serieJList = new javax.swing.JList();
        jScrollPane4 = new javax.swing.JScrollPane();
        gameJList = new javax.swing.JList();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        selectedGamesJList = new javax.swing.JList();
        jPanel6 = new javax.swing.JPanel();
        resultsButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Average results");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel3.setLayout(new java.awt.GridLayout(4, 1));

        testJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                testJListValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(testJList);

        jPanel3.add(jScrollPane1);

        expJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                expJListValueChanged(evt);
            }
        });

        jScrollPane2.setViewportView(expJList);

        jPanel3.add(jScrollPane2);

        serieJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                serieJListValueChanged(evt);
            }
        });

        jScrollPane3.setViewportView(serieJList);

        jPanel3.add(jScrollPane3);

        gameJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                gameJListValueChanged(evt);
            }
        });

        jScrollPane4.setViewportView(gameJList);

        jPanel3.add(jScrollPane4);

        jPanel2.add(jPanel3, java.awt.BorderLayout.WEST);

        jPanel4.setLayout(new java.awt.GridLayout(2, 1));

        jPanel5.setLayout(new java.awt.BorderLayout());

        jScrollPane5.setViewportView(selectedGamesJList);

        jPanel5.add(jScrollPane5, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel5);

        jPanel6.setLayout(new java.awt.GridBagLayout());

        resultsButton.setText("Results");
        resultsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resultsButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel6.add(resultsButton, gridBagConstraints);

        jPanel4.add(jPanel6);

        jPanel2.add(jPanel4, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void resultsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_resultsButtonActionPerformed
        // Add your handling code here:
        ViewResultsPlayersRankingDialog dialog = new ViewResultsPlayersRankingDialog(null,false, gameList, querys);
        dialog.setVisible(true);
    }//GEN-LAST:event_resultsButtonActionPerformed

    private void gameJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_gameJListValueChanged
        // Add your handling code here:
        if (gameJList.getSelectedValue()!=null) {
            selectedGame = (Game)gameJList.getSelectedValue();
            display(selectedGame);
        }
    }//GEN-LAST:event_gameJListValueChanged

    private void display(Game game) {
        gameList = querys.getAllGames(selectedTest.getIdTest(),game.getName());
        selectedGamesJList.setListData(gameList.toArray());
    }
    
    private void serieJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_serieJListValueChanged
        // Add your handling code here:
        if (serieJList.getSelectedValue()!=null) {
            Serie serie = (Serie)serieJList.getSelectedValue();
            selectedSerie = serie;
            ArrayList l = querys.getAllGames(serie.getIdSerie());
            gameJList.setListData(l.toArray());
            selectedGamesJList.setListData(new ArrayList().toArray());
        }
    }//GEN-LAST:event_serieJListValueChanged

    private void expJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_expJListValueChanged
        // Add your handling code here:
        if (expJList.getSelectedValue()!=null) {
            Exp exp = (Exp)expJList.getSelectedValue();
            selectedExp = exp;
            ArrayList l = querys.getAllSeries(exp.getIdExp());
            serieJList.setListData(l.toArray());
            gameJList.setListData(new ArrayList().toArray());
            selectedGamesJList.setListData(new ArrayList().toArray());
        }
    }//GEN-LAST:event_expJListValueChanged

    private void testJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_testJListValueChanged
        // Add your handling code here:
        if (testJList.getSelectedValue()!=null) {
            Test t = (Test)testJList.getSelectedValue();
            selectedTest = t;
            ArrayList l = querys.getAllExps(t.getIdTest());
            expJList.setListData(l.toArray());
            serieJList.setListData(new ArrayList().toArray());
            gameJList.setListData(new ArrayList().toArray());
            selectedGamesJList.setListData(new ArrayList().toArray());
        }
    }//GEN-LAST:event_testJListValueChanged

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JList expJList;
    private javax.swing.JList gameJList;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JButton resultsButton;
    private javax.swing.JList selectedGamesJList;
    private javax.swing.JList serieJList;
    private javax.swing.JList testJList;
    // End of variables declaration//GEN-END:variables
    
}
