/*
 * ViewCoalitionRankingDialog.java
 *
 * Created on 6 juin 2004, 01:48
 */

package simulations.database.gui;

import simulations.database.core.Querys;
import simulations.database.core.Exp;
import simulations.database.core.Game;
import simulations.database.core.Player;
import simulations.database.core.CoalitionsRanking;
import simulations.database.core.Serie;
import simulations.database.core.Strategy;
import simulations.database.core.Test;

import java.util.ArrayList;
import java.util.Vector;
import java.util.Iterator;

import javax.swing.JTable;

/**
 *
 * @author  tom
 */
public class ViewCoalitionRankingDialog extends javax.swing.JDialog {
    
    private Querys querys;
    
    private JTable table;
    
    private Game game;
    
    private java.awt.Frame parent;
    
    /** Creates new form ViewCoalitionRankingDialog */
    public ViewCoalitionRankingDialog(java.awt.Frame parent, boolean modal, Querys querys, Game game) {
        super(parent, modal);
        initComponents();
        this.parent=parent;
        this.querys=querys;
        this.game=game;
        Serie serie = querys.getSerie(game.getIdSerie());
        Exp exp = querys.getExp(serie.getIdExp());
        Test test = querys.getTest(exp.getIdTest());
        label.setText("game \""+game.getName()+"\" from serie \""+serie.getName()+"\" from exp \""+exp.getName()+"\" from test \""+test.getName()+"\"");
        ArrayList l = querys.getAllCoalitionsRanking(game.getIdGame());
        Vector titles = new Vector();
        titles.add("Rank");
        titles.add("Coalition");
        titles.add("Nb occ");
        titles.add("Nb seq occ");
        titles.add("Lg max");
        Vector data = new Vector();
        for(int i=0;i<l.size();i++) {
            CoalitionsRanking coalR = (CoalitionsRanking)l.get(i);
            ArrayList plList = querys.getAllPlayersInCoal(coalR.getIdCoalition());
            Vector line = new Vector();
            line.add(""+coalR.getRank());
            line.add(plList.toString());
            line.add(""+coalR.getNbOcc());
            line.add(""+coalR.getNbSeq());
            line.add(""+coalR.getLgMax());
            data.add(line);
        }
        table = new JTable(data,titles);
        scrollPane.setViewportView(table);
        this.validate();
        this.setSize(650, 500);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        descriptionButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        scrollPane = new javax.swing.JScrollPane();
        label = new javax.swing.JLabel();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Coalitions ranking");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        descriptionButton.setText("Game description");
        descriptionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                descriptionButtonActionPerformed(evt);
            }
        });

        jPanel1.add(descriptionButton);

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel4.setLayout(new java.awt.BorderLayout());

        jPanel4.add(scrollPane, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel4, java.awt.BorderLayout.CENTER);

        jPanel2.add(label, java.awt.BorderLayout.NORTH);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void descriptionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_descriptionButtonActionPerformed
        // Add your handling code here:
        ViewGameDescriptionDialog dialog = new ViewGameDescriptionDialog(parent, false, game, querys);
        dialog.setVisible(true);
    }//GEN-LAST:event_descriptionButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JButton descriptionButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JLabel label;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
    
}
