/*
 * ViewGameByStrategy.java
 *
 * Created on 14 juin 2004, 13:50
 */

package simulations.database.gui;

import simulations.database.core.Querys;
import simulations.database.core.Game;
import simulations.database.core.Serie;
import simulations.database.core.Exp;
import simulations.database.core.Test;
import simulations.database.core.AttackStrat;
import simulations.database.core.AskingStrat;
import simulations.database.core.DecisionStrat;

import javax.swing.SpinnerNumberModel;

import java.util.ArrayList;

/**
 *
 * @author  tom
 */
public class ViewGameByStrategy extends javax.swing.JDialog {
    
    private Querys querys;
    
    private Game game;
    
    private java.awt.Frame parent;
    
    private ArrayList attackList;
    
    private ArrayList askingList;
    
    private ArrayList decisionList;
    
    /** Creates new form ViewGameByStrategy */
    public ViewGameByStrategy(java.awt.Frame parent, boolean modal, Querys querys) {
        super(parent, modal);
        initComponents();
        this.querys=querys;
        this.parent=parent;
        attackList = new ArrayList();
        askingList = new ArrayList();
        decisionList = new ArrayList();
        init();
    }
    
    private void init() {
        ArrayList l = querys.getAllAttackStrat();
        attackJList.setListData(l.toArray());
        ArrayList l2 = querys.getAllAskingStrat();
        askingJList.setListData(l2.toArray());
        ArrayList l3 = querys.getAllDecisionStrat();
        decisionJList.setListData(l3.toArray());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        searchButton = new javax.swing.JButton();
        descriptionButton = new javax.swing.JButton();
        playersRankingButton = new javax.swing.JButton();
        coalitionButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jPanel9 = new javax.swing.JPanel();
        addAttackButton = new javax.swing.JButton();
        jScrollPane3 = new javax.swing.JScrollPane();
        attackJList = new javax.swing.JList();
        jPanel8 = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        addAskingButton = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        askingJList = new javax.swing.JList();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jPanel11 = new javax.swing.JPanel();
        addDecisionButton = new javax.swing.JButton();
        jScrollPane5 = new javax.swing.JScrollPane();
        decisionJList = new javax.swing.JList();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        descriptionTextArea = new javax.swing.JTextArea();
        jPanel12 = new javax.swing.JPanel();
        jPanel13 = new javax.swing.JPanel();
        jScrollPane6 = new javax.swing.JScrollPane();
        selectedAttackJList = new javax.swing.JList();
        removeAttackButton = new javax.swing.JButton();
        jPanel14 = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        selectedAskingJList = new javax.swing.JList();
        removeAskingButton = new javax.swing.JButton();
        jPanel15 = new javax.swing.JPanel();
        jScrollPane7 = new javax.swing.JScrollPane();
        selectedDecisionJList = new javax.swing.JList();
        removeDecisionButton = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        selectedGameJList = new javax.swing.JList();
        jPanel16 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        testLabel = new javax.swing.JLabel();
        expLabel = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        serieLabel = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("View game by strategy");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        searchButton.setText("Search");
        searchButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchButtonActionPerformed(evt);
            }
        });

        jPanel1.add(searchButton);

        descriptionButton.setText("Game description");
        descriptionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                descriptionButtonActionPerformed(evt);
            }
        });

        jPanel1.add(descriptionButton);

        playersRankingButton.setText("View players ranking");
        playersRankingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                playersRankingButtonActionPerformed(evt);
            }
        });

        jPanel1.add(playersRankingButton);

        coalitionButton.setText("View coalitions ranking");
        coalitionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                coalitionButtonActionPerformed(evt);
            }
        });

        jPanel1.add(coalitionButton);

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridLayout(1, 4));

        jPanel3.setLayout(new java.awt.GridLayout(2, 1));

        jPanel7.setLayout(new java.awt.BorderLayout());

        addAttackButton.setText("Add");
        addAttackButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addAttackButtonActionPerformed(evt);
            }
        });

        jPanel9.add(addAttackButton);

        jPanel7.add(jPanel9, java.awt.BorderLayout.SOUTH);

        jScrollPane3.setViewportView(attackJList);

        jPanel7.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        jPanel3.add(jPanel7);

        jPanel8.setLayout(new java.awt.BorderLayout());

        addAskingButton.setText("Add");
        addAskingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addAskingButtonActionPerformed(evt);
            }
        });

        jPanel10.add(addAskingButton);

        jPanel8.add(jPanel10, java.awt.BorderLayout.SOUTH);

        jScrollPane4.setViewportView(askingJList);

        jPanel8.add(jScrollPane4, java.awt.BorderLayout.CENTER);

        jPanel3.add(jPanel8);

        jPanel2.add(jPanel3);

        jPanel4.setLayout(new java.awt.GridLayout(2, 1));

        jPanel5.setLayout(new java.awt.BorderLayout());

        addDecisionButton.setText("Add");
        addDecisionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addDecisionButtonActionPerformed(evt);
            }
        });

        jPanel11.add(addDecisionButton);

        jPanel5.add(jPanel11, java.awt.BorderLayout.SOUTH);

        jScrollPane5.setViewportView(decisionJList);

        jPanel5.add(jScrollPane5, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel5);

        jPanel6.setLayout(new java.awt.BorderLayout());

        jScrollPane2.setViewportView(descriptionTextArea);

        jPanel6.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel6);

        jPanel2.add(jPanel4);

        jPanel12.setLayout(new java.awt.GridLayout(3, 1));

        jPanel13.setLayout(new java.awt.BorderLayout());

        jScrollPane6.setViewportView(selectedAttackJList);

        jPanel13.add(jScrollPane6, java.awt.BorderLayout.CENTER);

        removeAttackButton.setText("Remove");
        removeAttackButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeAttackButtonActionPerformed(evt);
            }
        });

        jPanel13.add(removeAttackButton, java.awt.BorderLayout.SOUTH);

        jPanel12.add(jPanel13);

        jPanel14.setLayout(new java.awt.BorderLayout());

        jScrollPane8.setViewportView(selectedAskingJList);

        jPanel14.add(jScrollPane8, java.awt.BorderLayout.CENTER);

        removeAskingButton.setText("Remove");
        removeAskingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeAskingButtonActionPerformed(evt);
            }
        });

        jPanel14.add(removeAskingButton, java.awt.BorderLayout.SOUTH);

        jPanel12.add(jPanel14);

        jPanel15.setLayout(new java.awt.BorderLayout());

        jScrollPane7.setViewportView(selectedDecisionJList);

        jPanel15.add(jScrollPane7, java.awt.BorderLayout.CENTER);

        removeDecisionButton.setText("Remove");
        removeDecisionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                removeDecisionButtonActionPerformed(evt);
            }
        });

        jPanel15.add(removeDecisionButton, java.awt.BorderLayout.SOUTH);

        jPanel12.add(jPanel15);

        jPanel2.add(jPanel12);

        selectedGameJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                selectedGameJListValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(selectedGameJList);

        jPanel2.add(jScrollPane1);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        jPanel16.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Test : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel16.add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        jPanel16.add(testLabel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        jPanel16.add(expLabel, gridBagConstraints);

        jLabel3.setText("Exp : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel16.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        jPanel16.add(serieLabel, gridBagConstraints);

        jLabel4.setText("Serie : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        jPanel16.add(jLabel4, gridBagConstraints);

        getContentPane().add(jPanel16, java.awt.BorderLayout.EAST);

        pack();
    }//GEN-END:initComponents

    private void coalitionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_coalitionButtonActionPerformed
        // Add your handling code here:
        ViewCoalitionRankingDialog dialog = new ViewCoalitionRankingDialog(parent, false, querys, game);
        dialog.setVisible(true);
    }//GEN-LAST:event_coalitionButtonActionPerformed

    private void playersRankingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_playersRankingButtonActionPerformed
        // Add your handling code here:
        ViewPlayersRankingDialog dialog = new ViewPlayersRankingDialog(parent, false, querys, game);
        dialog.setVisible(true);
    }//GEN-LAST:event_playersRankingButtonActionPerformed

    private void descriptionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_descriptionButtonActionPerformed
        // Add your handling code here:
        ViewGameDescriptionDialog dialog = new ViewGameDescriptionDialog(parent, false, game, querys);
        dialog.setVisible(true);
    }//GEN-LAST:event_descriptionButtonActionPerformed

    private void selectedGameJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_selectedGameJListValueChanged
        // Add your handling code here:
        if (selectedGameJList.getSelectedValue()!=null) {
            game = (Game)selectedGameJList.getSelectedValue();
            Serie serie = querys.getSerie(game.getIdSerie());
            Exp exp = querys.getExp(serie.getIdExp());
            Test test = querys.getTest(exp.getIdTest());
            serieLabel.setText(serie.getName());
            expLabel.setText(exp.getName());
            testLabel.setText(test.getName());
        } else {
            serieLabel.setText("");
            expLabel.setText("");
            testLabel.setText("");
        }
    }//GEN-LAST:event_selectedGameJListValueChanged

    private void searchButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchButtonActionPerformed
        // Add your handling code here:
        ArrayList l = querys.getAllGamesByStrat(attackList,askingList,decisionList);
        selectedGameJList.setListData(l.toArray());
    }//GEN-LAST:event_searchButtonActionPerformed

    private void removeDecisionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeDecisionButtonActionPerformed
        // Add your handling code here:
        if (selectedDecisionJList.getSelectedValue()!=null) {
            DecisionStrat decStrat = (DecisionStrat)selectedDecisionJList.getSelectedValue();
            decisionList.remove(decStrat);
            selectedDecisionJList.setListData(decisionList.toArray());
        }
    }//GEN-LAST:event_removeDecisionButtonActionPerformed

    private void removeAskingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeAskingButtonActionPerformed
        // Add your handling code here:
        if (selectedAskingJList.getSelectedValue()!=null) {
            AskingStrat askStrat = (AskingStrat)selectedAskingJList.getSelectedValue();
            askingList.remove(askStrat);
            selectedAskingJList.setListData(askingList.toArray());
        }
    }//GEN-LAST:event_removeAskingButtonActionPerformed

    private void removeAttackButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_removeAttackButtonActionPerformed
        // Add your handling code here:
        if (selectedAttackJList.getSelectedValue()!=null) {
            AttackStrat attStrat = (AttackStrat)selectedAttackJList.getSelectedValue();
            attackList.remove(attStrat);
            selectedAttackJList.setListData(attackList.toArray());
        }
    }//GEN-LAST:event_removeAttackButtonActionPerformed

    private void addDecisionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addDecisionButtonActionPerformed
        // Add your handling code here:
        if (decisionJList.getSelectedValue()!=null) {
            DecisionStrat decStrat = (DecisionStrat)decisionJList.getSelectedValue();
            if (!(decisionList.contains(decStrat))) {
                decisionList.add(decStrat);
                selectedDecisionJList.setListData(decisionList.toArray());
            }
        }
    }//GEN-LAST:event_addDecisionButtonActionPerformed

    private void addAskingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAskingButtonActionPerformed
        // Add your handling code here:
        if (askingJList.getSelectedValue()!=null) {
            AskingStrat askStrat = (AskingStrat)askingJList.getSelectedValue();
            if (!(askingList.contains(askStrat))) {
                askingList.add(askStrat);
                selectedAskingJList.setListData(askingList.toArray());
            }
        }
    }//GEN-LAST:event_addAskingButtonActionPerformed

    private void addAttackButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addAttackButtonActionPerformed
        // Add your handling code here:
        if (attackJList.getSelectedValue()!=null) {
            AttackStrat attStrat = (AttackStrat)attackJList.getSelectedValue();
            if (!(attackList.contains(attStrat))) {
                attackList.add(attStrat);
                selectedAttackJList.setListData(attackList.toArray());
            }
        }
    }//GEN-LAST:event_addAttackButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addAskingButton;
    private javax.swing.JButton addAttackButton;
    private javax.swing.JButton addDecisionButton;
    private javax.swing.JList askingJList;
    private javax.swing.JList attackJList;
    private javax.swing.JButton closeButton;
    private javax.swing.JButton coalitionButton;
    private javax.swing.JList decisionJList;
    private javax.swing.JButton descriptionButton;
    private javax.swing.JTextArea descriptionTextArea;
    private javax.swing.JLabel expLabel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JButton playersRankingButton;
    private javax.swing.JButton removeAskingButton;
    private javax.swing.JButton removeAttackButton;
    private javax.swing.JButton removeDecisionButton;
    private javax.swing.JButton searchButton;
    private javax.swing.JList selectedAskingJList;
    private javax.swing.JList selectedAttackJList;
    private javax.swing.JList selectedDecisionJList;
    private javax.swing.JList selectedGameJList;
    private javax.swing.JLabel serieLabel;
    private javax.swing.JLabel testLabel;
    // End of variables declaration//GEN-END:variables
    
}

