/*
 * ViewGameDescriptionDialog.java
 *
 * Created on 11 juin 2004, 22:45
 */

package simulations.database.gui;

import simulations.database.core.Querys;
import simulations.database.core.Game;
import simulations.database.core.Player;
import simulations.database.core.Strategy;

import java.util.ArrayList;

/**
 *
 * @author  tom
 */
public class ViewGameDescriptionDialog extends javax.swing.JDialog {
    
    private Querys querys;
    
    private Game game;
    
    /** Creates new form ViewGameDescriptionDialog */
    public ViewGameDescriptionDialog(java.awt.Frame parent, boolean modal, Game game, Querys querys) {
        super(parent, modal);
        this.querys=querys;
        this.game=game;
        initComponents();
        titleLabel.setText(titleLabel.getText()+" "+game.getName());
        initJList();
        repaint();
    }
    
    private void initJList() {
        ArrayList l = querys.getAllPlayers(game.getIdGame());
        playerJList.setListData(l.toArray());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        titleLabel = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        closeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        playerJList = new javax.swing.JList();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        descriptionTextArea = new javax.swing.JTextArea();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        titleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        titleLabel.setText("Description of game");
        getContentPane().add(titleLabel, java.awt.BorderLayout.NORTH);

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridLayout(1, 2));

        jPanel3.setLayout(new java.awt.BorderLayout());

        playerJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                playerJListValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(playerJList);

        jPanel3.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel3);

        jPanel4.setLayout(new java.awt.BorderLayout());

        descriptionTextArea.setEditable(false);
        jScrollPane2.setViewportView(descriptionTextArea);

        jPanel4.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jPanel2.add(jPanel4);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void playerJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_playerJListValueChanged
        // Add your handling code here:
        if (playerJList.getSelectedValue()!=null) {
            Player p = (Player)playerJList.getSelectedValue();
            descriptionTextArea.setText(querys.getStrategyDescription(p.getIdStrategy()));
        } else {
            descriptionTextArea.setText("");
        }
    }//GEN-LAST:event_playerJListValueChanged

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JTextArea descriptionTextArea;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JList playerJList;
    private javax.swing.JLabel titleLabel;
    // End of variables declaration//GEN-END:variables
    
}
