/*
 * ViewGameDialog.java
 *
 * Created on 5 juin 2004, 20:41
 */

package simulations.database.gui;

import simulations.database.core.Querys;
import simulations.database.core.Exp;
import simulations.database.core.Game;
import simulations.database.core.Player;
import simulations.database.core.Serie;
import simulations.database.core.Strategy;
import simulations.database.core.Test;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author  tom
 */
public class ViewGameDialog extends javax.swing.JDialog {
    
    private Querys querys;
    
    private ArrayList testList;
    
    private Test selectedTest;
    
    private ArrayList expList;
    
    private Exp selectedExp;
    
    private ArrayList serieList;
    
    private Serie selectedSerie;
    
    private ArrayList gameList;
    
    private Game selectedGame;
    
    private ArrayList playerList;
    
    private Player selectedPlayer;
    
    private java.awt.Frame parent;
    
    /** Creates new form ViewGameDialog */
    public ViewGameDialog(java.awt.Frame parent, boolean modal, Querys querys) {
        super(parent, modal);
        initComponents();
        this.parent=parent;
        this.querys=querys;
        testList = new ArrayList();
        testList = querys.getAllTests();
        testJList.setListData(testList.toArray());
        expList = new ArrayList();
        serieList = new ArrayList();
        gameList = new ArrayList();
        playerList = new ArrayList();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        playerRankingButton = new javax.swing.JButton();
        coalitionRankingButton = new javax.swing.JButton();
        descriptionButton = new javax.swing.JButton();
        coalitionStatsButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        testJList = new javax.swing.JList();
        jPanel7 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        expJList = new javax.swing.JList();
        jPanel4 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        serieJList = new javax.swing.JList();
        jPanel9 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        gameJList = new javax.swing.JList();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        playerJList = new javax.swing.JList();
        jScrollPane6 = new javax.swing.JScrollPane();
        strategyTextArea = new javax.swing.JTextArea();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("View Game");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        playerRankingButton.setText("Players ranking");
        playerRankingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                playerRankingButtonActionPerformed(evt);
            }
        });

        jPanel1.add(playerRankingButton);

        coalitionRankingButton.setText("Coalitions ranking");
        coalitionRankingButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                coalitionRankingButtonActionPerformed(evt);
            }
        });

        jPanel1.add(coalitionRankingButton);

        descriptionButton.setText("Game description");
        descriptionButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                descriptionButtonActionPerformed(evt);
            }
        });

        jPanel1.add(descriptionButton);

        coalitionStatsButton.setText("Coalition stats");
        coalitionStatsButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                coalitionStatsButtonActionPerformed(evt);
            }
        });

        jPanel1.add(coalitionStatsButton);

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridLayout(1, 3));

        jPanel3.setLayout(new java.awt.GridLayout(2, 1));

        jPanel6.setLayout(new java.awt.BorderLayout());

        testJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                testJListValueChanged(evt);
            }
        });

        jScrollPane1.setViewportView(testJList);

        jPanel6.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel3.add(jPanel6);

        jPanel7.setLayout(new java.awt.BorderLayout());

        expJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                expJListValueChanged(evt);
            }
        });

        jScrollPane2.setViewportView(expJList);

        jPanel7.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jPanel3.add(jPanel7);

        jPanel2.add(jPanel3);

        jPanel4.setLayout(new java.awt.GridLayout(2, 1));

        jPanel8.setLayout(new java.awt.BorderLayout());

        serieJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                serieJListValueChanged(evt);
            }
        });

        jScrollPane3.setViewportView(serieJList);

        jPanel8.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel8);

        jPanel9.setLayout(new java.awt.BorderLayout());

        gameJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                gameJListValueChanged(evt);
            }
        });

        jScrollPane4.setViewportView(gameJList);

        jPanel9.add(jScrollPane4, java.awt.BorderLayout.CENTER);

        jPanel4.add(jPanel9);

        jPanel2.add(jPanel4);

        jPanel5.setLayout(new java.awt.GridLayout(2, 1));

        playerJList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                playerJListValueChanged(evt);
            }
        });

        jScrollPane5.setViewportView(playerJList);

        jPanel5.add(jScrollPane5);

        jScrollPane6.setViewportView(strategyTextArea);

        jPanel5.add(jScrollPane6);

        jPanel2.add(jPanel5);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void coalitionStatsButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_coalitionStatsButtonActionPerformed
        // Add your handling code here:
        ViewCoalitionStats dialog = new ViewCoalitionStats(null, true, querys, selectedGame);
        dialog.setVisible(true);
    }//GEN-LAST:event_coalitionStatsButtonActionPerformed

    private void descriptionButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_descriptionButtonActionPerformed
        // Add your handling code here:
        ViewGameDescriptionDialog dialog = new ViewGameDescriptionDialog(parent, false, selectedGame, querys);
        dialog.setVisible(true);
    }//GEN-LAST:event_descriptionButtonActionPerformed

    private void coalitionRankingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_coalitionRankingButtonActionPerformed
        // Add your handling code here:
        if (gameJList.getSelectedValue()!=null) {
            ViewCoalitionRankingDialog dialog = new ViewCoalitionRankingDialog(parent,false,querys,selectedGame);
            dialog.setVisible(true);
        }
    }//GEN-LAST:event_coalitionRankingButtonActionPerformed

    private void playerRankingButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_playerRankingButtonActionPerformed
        // Add your handling code here:
        if (gameJList.getSelectedValue()!=null) {
            ViewPlayersRankingDialog dialog = new ViewPlayersRankingDialog(parent,false,querys,selectedGame);
            dialog.setVisible(true);
        }
    }//GEN-LAST:event_playerRankingButtonActionPerformed

    private void playerJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_playerJListValueChanged
        // Add your handling code here:
        if (playerJList.getSelectedValue()==null) {
            return;
        }
        Player p = (Player)playerJList.getSelectedValue();
        strategyTextArea.setText(querys.getStrategyDescription(p.getIdStrategy()));
    }//GEN-LAST:event_playerJListValueChanged

    private void gameJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_gameJListValueChanged
        // Add your handling code here:
        if (gameJList.getSelectedValue()==null) {
            return;
        }
        Game game = (Game)gameJList.getSelectedValue();
        selectedGame=game;
        playerList.clear();
        playerList = querys.getAllPlayers(game.getIdGame());
        playerJList.setListData(playerList.toArray());
    }//GEN-LAST:event_gameJListValueChanged

    private void serieJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_serieJListValueChanged
        // Add your handling code here:
        if (serieJList.getSelectedValue()==null) {
            return;
        }
        Serie serie = (Serie)serieJList.getSelectedValue();
        selectedSerie=serie;
        gameList.clear();
        gameList = querys.getAllGames(serie.getIdSerie());
        gameJList.setListData(gameList.toArray());
        playerList.clear();
        playerJList.setListData(playerList.toArray());
    }//GEN-LAST:event_serieJListValueChanged

    private void expJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_expJListValueChanged
        // Add your handling code here:
        if (expJList.getSelectedValue()==null) {
            return;
        }
        Exp exp = (Exp)expJList.getSelectedValue();
        serieList.clear();
        selectedExp=exp;
        serieList = querys.getAllSeries(exp.getIdExp());
        serieJList.setListData(serieList.toArray());
        gameList.clear();
        gameJList.setListData(gameList.toArray());
        playerList.clear();
        playerJList.setListData(playerList.toArray());
    }//GEN-LAST:event_expJListValueChanged

    private void testJListValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_testJListValueChanged
        // Add your handling code here:
        if (testJList.getSelectedValue()==null) {
            return;
        }
        Test test = (Test)testJList.getSelectedValue();
        serieList.clear();
        selectedTest=test;
        serieJList.setListData(serieList.toArray());
        gameList.clear();
        gameJList.setListData(gameList.toArray());
        playerList.clear();
        playerJList.setListData(playerList.toArray());
        expList.clear();
        expList = querys.getAllExps(test.getIdTest());
        expJList.setListData(expList.toArray());
    }//GEN-LAST:event_testJListValueChanged

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
       
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JButton coalitionRankingButton;
    private javax.swing.JButton coalitionStatsButton;
    private javax.swing.JButton descriptionButton;
    private javax.swing.JList expJList;
    private javax.swing.JList gameJList;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JList playerJList;
    private javax.swing.JButton playerRankingButton;
    private javax.swing.JList serieJList;
    private javax.swing.JTextArea strategyTextArea;
    private javax.swing.JList testJList;
    // End of variables declaration//GEN-END:variables
    
}
