/*
 * ViewResultsPlayersRankingDialog.java
 *
 * Created on 9 juin 2004, 00:08
 */

package simulations.database.gui;

import javax.swing.JTable;

import simulations.database.core.Game;
import simulations.database.core.PlayersRanking;
import simulations.database.core.Player;
import simulations.database.core.Querys;

import java.util.ArrayList;
import java.util.Vector;
import java.util.HashMap;
import java.util.Set;
import java.util.Iterator;
import java.util.Map.Entry;

/**
 *
 * @author  tom
 */
public class ViewResultsPlayersRankingDialog extends javax.swing.JDialog {
    
    private JTable table;
    
    private ArrayList gameList;
    
    private Querys querys;
    
    /** Creates new form ViewResultsPlayersRankingDialog */
    public ViewResultsPlayersRankingDialog(java.awt.Frame parent, boolean modal, ArrayList gameList, Querys querys) {
        super(parent, modal);
        initComponents();
        this.gameList=gameList;
        display(gameList);
    }
    
    private void display(ArrayList gameList) {
        ArrayList plrList = querys.getAllPlayersRanking(((Game)gameList.get(0)).getIdGame());
        int nbP = plrList.size();
        HashMap hashMapTurn = new HashMap();
        HashMap hashMapRank = new HashMap();
        for(int i=0;i<gameList.size();i++) {
            plrList = querys.getAllPlayersRanking(((Game)gameList.get(i)).getIdGame());
            for(int j=0;j<plrList.size();j++) {
                PlayersRanking plr = (PlayersRanking)plrList.get(j);
                Player p = (Player)querys.getPlayer(plr.getIdPlayer());
                if (hashMapTurn.containsKey(p.getName())) {
                    Integer nb =(Integer)hashMapTurn.get(p.getName());
                    nb = new Integer(nb.intValue()+plr.getLastTurn());
                    hashMapTurn.put(p.getName(), nb);
                } else {
                    hashMapTurn.put(p.getName(), new Integer(plr.getLastTurn()));
                }
                if (hashMapRank.containsKey(p.getName())) {
                    Integer nb =(Integer)hashMapRank.get(p.getName());
                    nb = new Integer(nb.intValue()+(nbP-plr.getRank()));
                    hashMapRank.put(p.getName(), nb);
                } else {
                    hashMapRank.put(p.getName(), new Integer(nbP-plr.getRank()));
                }
            }
        }
        Vector title = new Vector();
        Vector data = new Vector();
        title.addElement("Rank");
        title.addElement("Player");
        title.addElement("Strategy");
        title.addElement("Total turns");
        title.addElement("Total rank");
        ArrayList l = orderedPlayerList(hashMapTurn);
        for(int i=0;i<l.size();i++) {
            Vector line = new Vector();
            line.addElement(""+i);
            Player p = (Player)l.get(i);
            line.addElement(p);
            line.addElement(querys.getStrategy(p.getIdStrategy()));
            line.addElement((Integer)hashMapTurn.get(p.getName()));
            line.addElement((Integer)hashMapRank.get(p.getName()));
        }
        JTable table = new JTable(data, title);
        scrollPane.setViewportView(table);
    }
    
    private ArrayList orderedPlayerList(HashMap hashMap) {
        Set set = hashMap.keySet();
        boolean[] validIndex = new boolean[set.size()];
        for(int i=0;i<validIndex.length;i++) {
            validIndex[i]=true;
        }
        ArrayList l = new ArrayList();
        int val = 0;
        while (!(finish(validIndex))) {
            int cpt=0;
            Player p = null;
            int ind = 0;
            Iterator it = set.iterator();
            while (it.hasNext()) {
                if (validIndex[cpt]) {
                    Entry entry = (Entry)it.next();
                    Integer nb = (Integer)entry.getValue();
                    if (nb.intValue()>=val) {
                        ind=cpt;
                        val=nb.intValue();
                        p = (Player)entry.getKey();
                    }
                }
                cpt++;
            }
            l.add(p);
            validIndex[ind]=false;
        }
        return l;
    }
    
    private boolean finish(boolean[] tab) {
        for(int i=0;i<tab.length;i++) {
            if (tab[i]) {
                return false;
            }
        }
        return true;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        closeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        scrollPane = new javax.swing.JScrollPane();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        playersRadioButton = new javax.swing.JRadioButton();
        strategyRadioButton = new javax.swing.JRadioButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jPanel2.add(scrollPane, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        jPanel3.setLayout(new java.awt.BorderLayout());

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Average results");
        jPanel3.add(jLabel1, java.awt.BorderLayout.CENTER);

        jLabel2.setText("Order by ");
        jPanel4.add(jLabel2);

        playersRadioButton.setText("Players");
        buttonGroup1.add(playersRadioButton);
        jPanel4.add(playersRadioButton);

        strategyRadioButton.setSelected(true);
        strategyRadioButton.setText("Strategies");
        buttonGroup1.add(strategyRadioButton);
        jPanel4.add(strategyRadioButton);

        jPanel3.add(jPanel4, java.awt.BorderLayout.SOUTH);

        getContentPane().add(jPanel3, java.awt.BorderLayout.NORTH);

        pack();
    }//GEN-END:initComponents

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton closeButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JRadioButton playersRadioButton;
    private javax.swing.JScrollPane scrollPane;
    private javax.swing.JRadioButton strategyRadioButton;
    // End of variables declaration//GEN-END:variables
    
}
