/*
 * ClassementSaver.java
 *
 * Created on 31 mai 2004, 14:03
 */

package simulations.gui;

import java.util.ArrayList;
import java.util.Iterator;

import simulations.core.strategy.PlayerIntElement;

import javax.swing.JLabel;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JFileChooser;

/**
 *
 * @author  tom
 */
public class ClassementSaver {
    
    /** The players ranking **/
    private ArrayList classement;
    
    /** Creates a new instance of ClassementSaver */
    public ClassementSaver(ArrayList classement) {
        this.classement=classement;
    }
    
    /** Save the players ranking table in f
     * @param f The file to save the table 
     **/
    public void save(File f) {
        try {
            if (simulations.SimulationParameters.debug) {
                System.out.println("saving classement in "+f.getPath());
            }
            FileWriter writer = new FileWriter(f);
            writer.write("<html>\n");
            writer.write("<title>Coalition ranking</title>\n");
            writer.write("<body>\n");
            writer.write("<h2><center>Coalition ranking</center></h2>\n");
            writer.write("<br>\n");
            writer.write("<center><table border>\n");
            writer.write("<tr><td>Rank</td><td>Player</td><td>Strategy</td><td>Last turn</td></tr>\n");
            Iterator it = classement.iterator();
            int cpt=1;
            while (it.hasNext()) {
                PlayerIntElement elt = (PlayerIntElement)it.next();
                writer.write("<tr><td>#"+cpt+"</td><td>"+elt.getPlayer()+"</td><td>"+
                elt.getPlayer().getStrategy().getName()+"</td><td>"+elt.getNb()+"</td></tr>\n");
                cpt++;
            }
            writer.write("</table></center>\n");
            writer.write("</body>\n");
            writer.write("</html>\n");
            writer.close();
        }catch(IOException e) {
            System.out.println(e.toString());
        }
    }
    
}
