/*
 * ComputeAvgTest210.java
 *
 * Created on 15 novembre 2004, 15:35
 */

package simulations.gui;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map.Entry;
import java.util.Iterator;

import javax.swing.JFileChooser;

import java.io.File;
import java.io.FileWriter;
import java.io.FileReader;
import java.io.IOException;

/**
 *
 * @author  tom
 */
public class ComputeAvgTest210 extends javax.swing.JDialog {
    
    private File htmlFile;
    
    private HashMap strategyPtsHashMap;
    
    private HashMap strategyAttPtsHashMap;
    
    private HashMap strategyAskPtsHashMap;
    
    private HashMap strategyDecPtsHashMap;
    
    /** Creates new form ComputeAvgTest210 */
    public ComputeAvgTest210(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        strategyAskPtsHashMap = new HashMap();
        strategyAttPtsHashMap = new HashMap();
        strategyDecPtsHashMap = new HashMap();
        strategyPtsHashMap = new HashMap();
    }
    
    /** Return the next line of the history file
     * @throws IOException Return an IOException in case of problem
     * @return Return the next line of the history file
     */    
    public String nextLine(FileReader fileReader) throws IOException {
        String s="";
        try {
            int c;
            char ch;
            while ((c=fileReader.read())>=0) {
                ch=(char)c;
                s=s.concat(s.valueOf(ch));
                if (ch=='\n') {
                    break;
                }
            }
        }catch(IOException e) {
            throw e;
        }
        return s;
    }
    
    private String getMin() {
        int min = 1000000;
        String minKey="";
        Iterator it = strategyPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            int nb = ((Integer)entry.getValue()).intValue();
            if (nb<min) {
                min = nb;
                minKey = (String)entry.getKey();
            }
        }
        return minKey;
    }
    
    private String getMax() {
        int max = 0;
        String maxKey="";
        Iterator it = strategyPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            int nb = ((Integer)entry.getValue()).intValue();
            if (nb>max) {
                max = nb;
                maxKey = (String)entry.getKey();
            }
        }
        return maxKey;
    }
    
    private String getMinAtt() {
        int min = 1000000;
        String minKey="";
        Iterator it = strategyAttPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            int nb = ((Integer)entry.getValue()).intValue();
            if (nb<min) {
                min = nb;
                minKey = (String)entry.getKey();
            }
        }
        return minKey;
    }
    
    private String getMaxAtt() {
        int max = 0;
        String maxKey="";
        Iterator it = strategyAttPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            int nb = ((Integer)entry.getValue()).intValue();
            if (nb>max) {
                max = nb;
                maxKey = (String)entry.getKey();
            }
        }
        return maxKey;
    }
    
    private String getMinAsk() {
        int min = 1000000;
        String minKey="";
        Iterator it = strategyAskPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            int nb = ((Integer)entry.getValue()).intValue();
            if (nb<min) {
                min = nb;
                minKey = (String)entry.getKey();
            }
        }
        return minKey;
    }
    
    private String getMaxAsk() {
        int max = 0;
        String maxKey="";
        Iterator it = strategyAskPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            int nb = ((Integer)entry.getValue()).intValue();
            if (nb>max) {
                max = nb;
                maxKey = (String)entry.getKey();
            }
        }
        return maxKey;
    }
    
    private String getMinDec() {
        int min = 1000000;
        String minKey="";
        Iterator it = strategyDecPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            int nb = ((Integer)entry.getValue()).intValue();
            if (nb<min) {
                min = nb;
                minKey = (String)entry.getKey();
            }
        }
        return minKey;
    }
    
    private String getMaxDec() {
        int max = 0;
        String maxKey="";
        Iterator it = strategyDecPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            int nb = ((Integer)entry.getValue()).intValue();
            if (nb>max) {
                max = nb;
                maxKey = (String)entry.getKey();
            }
        }
        return maxKey;
    }
    
    private String stratContains(String strat) {
        Iterator it = strategyPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            String s = (String)entry.getKey();
            if (s.equals(strat)) {
                return s;
            }
        }
        return null;
    }
    
    private String stratAttContains(String strat) {
        Iterator it = strategyAttPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            String s = (String)entry.getKey();
            if (s.equals(strat)) {
                return s;
            }
        }
        return null;
    }
    
    private String stratAskContains(String strat) {
        Iterator it = strategyAskPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            String s = (String)entry.getKey();
            if (s.equals(strat)) {
                return s;
            }
        }
        return null;
    }
    
    private String stratDecContains(String strat) {
        Iterator it = strategyDecPtsHashMap.entrySet().iterator();
        while (it.hasNext()) {
            Entry entry = (Entry)it.next();
            String s = (String)entry.getKey();
            if (s.equals(strat)) {
                return s;
            }
        }
        return null;
    }
    
    private void updateStratPts(String strat, int value) {
        String key = stratContains(strat);
        if (key!=null) {
            int val = ((Integer)strategyPtsHashMap.get(key)).intValue();
            val = val + value;
            strategyPtsHashMap.put(strat,new Integer(val));
        } else {
            strategyPtsHashMap.put(strat,new Integer(value));
        }
    }
    
    private void updateAttStratPts(String strat, int value) {
        String key = stratAttContains(strat);
        if (key!=null) {
            int val = ((Integer)strategyAttPtsHashMap.get(key)).intValue();
            val = val + value;
            strategyAttPtsHashMap.put(strat,new Integer(val));
        } else {
            strategyAttPtsHashMap.put(strat,new Integer(value));
        }
    }
    
    private void updateAskStratPts(String strat, int value) {
        String key = stratAskContains(strat);
        if (key!=null) {
            int val = ((Integer)strategyAskPtsHashMap.get(key)).intValue();
            val = val + value;
            strategyAskPtsHashMap.put(strat,new Integer(val));
        } else {
            strategyAskPtsHashMap.put(strat,new Integer(value));
        }
    }
    
    private void updateDecStratPts(String strat, int value) {
        String key = stratDecContains(strat);
        if (key!=null) {
            int val = ((Integer)strategyDecPtsHashMap.get(key)).intValue();
            val = val + value;
            strategyDecPtsHashMap.put(strat,new Integer(val));
        } else {
            strategyDecPtsHashMap.put(strat,new Integer(value));
        }
    }
    
    public void compute() {
        File rootFolder = new File(rootTextField.getText());
        File rootFolderList[] = rootFolder.listFiles();
        for(int i=0;i<rootFolderList.length;i++) {
            try {
                File currentSerie = rootFolderList[i];
                File summaryFile = new File(currentSerie.getAbsolutePath()+"/history/summary.txt");
                FileReader reader = new FileReader(summaryFile);
                for(int m=0;m<210;m++) {
                    nextLine(reader);
                    String playerName = nextLine(reader);
                    String lastTurnStr = nextLine(reader);
                    String strat = nextLine(reader);
                    try {
                        playerName = playerName.substring(0,playerName.length()-1);
                        lastTurnStr = lastTurnStr.substring(0,lastTurnStr.length()-1);
                        strat = strat.substring(0,strat.length()-1);
                        updateStratPts(strat,210-m);
                        String[] str = strat.split("-");
                        updateAttStratPts(str[0],210-m);
                        updateAskStratPts(str[1],210-m);
                        updateDecStratPts(str[2],210-m);
                    }catch(ArrayIndexOutOfBoundsException e) {
                        break;
                    }catch(StringIndexOutOfBoundsException e) {
                        break;
                    }
                    try {
                        int lastTurn = new Integer(lastTurnStr).intValue();
                    }catch(NumberFormatException e) {
                        
                    }
                    System.out.println("player name = "+playerName);
                    while (nextLine(reader).length()>1) {
                        //nextLine(reader);
                    }
                    
                }
                reader.close();
            }catch(IOException e) {
                System.out.println(e.toString());
                System.exit(0);
            }
        }
        writeHTMLFile();
    }
    
    private void writeHTMLFile() {
        String fileName = htmlFile.getName();
        try {
            FileWriter writer = new FileWriter(htmlFile);
            writer.write("<html>\n");
            writer.write("<body>\n");
            writer.write("<table border><tr><td>Strat</td><td>Pts</td><td>Att. strat</td><td>Pts</td><td>Ask. strat</td><td>Pts</td><td>Dec. strat</td><td>Pts</td></tr>\n");
            for(int i=0;i<strategyPtsHashMap.size();i++) {
                String key = getMax();
                int nb = ((Integer)strategyPtsHashMap.get(key)).intValue();
                writer.write("<tr><td>"+key+"</td><td>"+nb+"</td>");
                strategyPtsHashMap.remove(key);
                key = getMaxAtt();
                nb = ((Integer)strategyAttPtsHashMap.get(key)).intValue();
                writer.write("<td>"+key+"</td><td>"+nb+"</td>");
                strategyAttPtsHashMap.remove(key);
                key = getMaxAsk();
                nb = ((Integer)strategyAskPtsHashMap.get(key)).intValue();
                writer.write("<td>"+key+"</td><td>"+nb+"</td>");
                strategyAskPtsHashMap.remove(key);
                key = getMaxDec();
                nb = ((Integer)strategyDecPtsHashMap.get(key)).intValue();
                writer.write("<td>"+key+"</td><td>"+nb+"</td></tr>\n");
                strategyDecPtsHashMap.remove(key);
            }
            writer.write("</table>\n");
            writer.write("</body>\n");
            writer.write("</html>\n");
            writer.close();
        }catch(IOException e) {
            System.out.println(e.toString());
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        rootTextField = new javax.swing.JTextField();
        folderButton = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        targetTextField = new javax.swing.JTextField();
        targetButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        computeButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jLabel1.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Compute Avg of Test 210");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Root folder : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        jPanel1.add(jLabel2, gridBagConstraints);

        rootTextField.setColumns(25);
        rootTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        jPanel1.add(rootTextField, gridBagConstraints);

        folderButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        folderButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                folderButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        jPanel1.add(folderButton, gridBagConstraints);

        jLabel3.setText("Target file :");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        jPanel1.add(jLabel3, gridBagConstraints);

        targetTextField.setColumns(25);
        targetTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        jPanel1.add(targetTextField, gridBagConstraints);

        targetButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        targetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                targetButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        jPanel1.add(targetButton, gridBagConstraints);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        computeButton.setText("Compute");
        jPanel2.add(computeButton);

        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel2.add(closeButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void targetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_targetButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        StrategyFileFilter filter = new StrategyFileFilter();
        filter.addExtension("html");
        filter.setDescription("HTML file");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            String fileName = chooser.getSelectedFile().getPath();
            try {
                System.out.println(fileName);
            }catch(IndexOutOfBoundsException e) {
            }
            htmlFile=new File(fileName);
            targetTextField.setText(fileName);
        }
    }//GEN-LAST:event_targetButtonActionPerformed

    private void folderButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_folderButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            rootTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_folderButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // TODO add your handling code here:
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_closeButtonActionPerformed
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JButton computeButton;
    private javax.swing.JButton folderButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField rootTextField;
    private javax.swing.JButton targetButton;
    private javax.swing.JTextField targetTextField;
    // End of variables declaration//GEN-END:variables
    
}
