/*
 * CreateSmallTest1.java
 *
 * Created on 11 novembre 2004, 21:47
 */

package simulations.gui;

import java.util.ArrayList;
import java.util.Vector;
import java.util.Iterator;
import java.util.Random;
import java.util.GregorianCalendar;
import java.util.Calendar;

import javax.swing.JFileChooser;
import javax.swing.SpinnerNumberModel;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import simulations.core.strategy.StrategyLoader;
import simulations.core.strategy.attackStrategy.*;
import simulations.core.strategy.askingSupportStrategy.*;
import simulations.core.strategy.decisionSupportStrategy.*;
import simulations.core.strategy.completeStrategy.GenericComposedStrategy;
import simulations.xml.XMLGameWriter;

import simulations.core.Player;


/**
 *
 * @author  tom
 */
public class CreateSmallTest1 extends javax.swing.JDialog {
    
    private ArrayList strategyList;
    
    private File jarFile;
    
    /** Creates new form CreateSmallTest1 */
    public CreateSmallTest1(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        randomSeedSpinner.setModel(new SpinnerNumberModel(0,0,10000000,1));
        nbPlayersSpinner.setModel(new SpinnerNumberModel(30,3,10000000,1));
        strategyList = new ArrayList();
    }
    
    private void init() {
        int seed = ((Integer)randomSeedSpinner.getValue()).intValue();
        int nbPlayers = ((Integer)nbPlayersSpinner.getValue()).intValue();
        int hp = 0;
        int nbScripts = 0;
        try {
            nbScripts = new Integer(nbScriptsTextField.getText()).intValue();
            hp = new Integer(playersHPTextField.getText()).intValue();
        }catch(NumberFormatException e) {
            return;
        }
        int coalDef = 0;
        if (coalDef1RadioButton.isSelected()) {
            coalDef=0;
        } else if (coalDef2RadioButton.isSelected()) {
            coalDef=1;
        } else if (coalDef3RadioButton.isSelected()) {
            coalDef=2;
        } else if (coalDef4RadioButton.isSelected()) {
            coalDef=3;
        } else if (coalDef5RadioButton.isSelected()) {
            coalDef=4;
        }
        StrategyLoader loader = new StrategyLoader();
        ArrayList l1 = new ArrayList();
        ArrayList l2 = new ArrayList();
        ArrayList l3 = new ArrayList();
        AttackStrategy as;
        DecisionSupportStrategy ds;
        AskingStrategy aks;
        as = new simulations.core.strategy.attackStrategy.AttackStrongestThanMeStrategy();
        //as.setName("1-");
        l1.add(as);
        as = new simulations.core.strategy.attackStrategy.AttackWeakestThanMeStrategy();
        //as.setName("2-");
        l1.add(as);
        as = new simulations.core.strategy.attackStrategy.AttackStrongestStrategy();
        //as.setName("3-");
        l1.add(as);
        as = new simulations.core.strategy.attackStrategy.AttackWeakestStrategy();
        //as.setName("4-");
        l1.add(as);
        as = new simulations.core.strategy.attackStrategy.AttackAttackedPlayersStrategy();
        //as.setName("5-");
        l1.add(as);
        as = new simulations.core.strategy.attackStrategy.SpitefulAttackStrategy();
        //as.setName("6-");
        l1.add(as);
        aks = new simulations.core.strategy.askingSupportStrategy.AskingEveryoneStrategy();
        //aks.setName("1-");
        l2.add(aks);
        aks = new simulations.core.strategy.askingSupportStrategy.AskingNoBodyStrategy();
        //aks.setName("2-");
        l2.add(aks);
        aks = new simulations.core.strategy.askingSupportStrategy.AskingPlayersDontAttackMeStrategy();
        //aks.setName("3-");
        l2.add(aks);
        aks = new simulations.core.strategy.askingSupportStrategy.AskingStrongestThanMeStrategy();
        //aks.setName("4-");
        l2.add(aks);
        aks = new simulations.core.strategy.askingSupportStrategy.AskingWeakestThanMeStrategy();
        //aks.setName("5-");
        l2.add(aks);
        ds = new simulations.core.strategy.decisionSupportStrategy.AlwaysAcceptToSupportStrategy();
        //ds.setName("1");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.NeverAcceptToSupportStrategy();
        //ds.setName("2");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.AcceptAttackedPlayersStrongestThanMeStrategy();
        //ds.setName("3");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.AcceptAttackedPlayersWeakestThanMeStrategy();
        //ds.setName("4");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.AcceptAskingPlayersStrongestThanMe();
        //ds.setName("5");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.AcceptAskingPlayersWeakestThanMeStrategy();
        //ds.setName("6");
        l3.add(ds);
        ds = new simulations.core.strategy.decisionSupportStrategy.AcceptPlayersDontAttackMeStrategy();
        //ds.setName("7");
        l3.add(ds);
        ArrayList l11 = new ArrayList();
        ArrayList l12 = new ArrayList();
        ArrayList l13 = new ArrayList();
        Iterator it = l1.iterator();
        // create structs
        File readMe = new File(rootFolderTextField.getText()+"/description.txt");
        try {
            FileWriter readMeWriter = new FileWriter(readMe);
            readMeWriter.write("This folder contains tests series with all strategies of one filter\n");
            readMeWriter.write("Seed = "+seed+"\n");
            readMeWriter.close();
        }catch(IOException e) {
            System.out.println(e.toString());
        }
        try {
            Runtime runTime=Runtime.getRuntime();
            Process process=runTime.exec("cp "+jarFile.getPath()+" "+
            rootFolderTextField.getText());
        }catch(IOException e) {
            System.out.println(e.toString());
        }
        for(int i=0;i<100;i++) {
            File fDir = null;
            fDir = new File(rootFolderTextField.getText()+"/serie"+i);
            fDir.mkdir();
            fDir = new File(rootFolderTextField.getText()+"/serie"+i+"/scripts");
            fDir.mkdir();
            fDir = new File(rootFolderTextField.getText()+"/serie"+i+"/xmlGameFiles");
            fDir.mkdir();
            fDir = new File(rootFolderTextField.getText()+"/serie"+i+"/history");
            fDir.mkdir();
            fDir = new File(rootFolderTextField.getText()+"/serie"+i+"/graph");
            fDir.mkdir();
        }
        //File f = new File(rootFolderTextField.getText()+"");
        while (it.hasNext()) {
            try {
                AttackStrategy attackStrat = (AttackStrategy)it.next();
                if (attackStrat.getName().indexOf("Coalition")>=0) {
                    continue;
                }
                AttackStrategy newStrat1 = (AttackStrategy)attackStrat.getClass().newInstance();
                newStrat1.setName(attackStrat.getName());
                newStrat1.setMemory(0);
                newStrat1.setNegative(false);
                l11.add(newStrat1);
            }catch(InstantiationException e) {
                System.out.println(e.toString());
            }catch(IllegalAccessException e) {
                System.out.println(e.toString());
            }
        }
        
        it = l2.iterator();
        
        while (it.hasNext()) {
            try {
                AskingStrategy askingStrat = (AskingStrategy)it.next();
                if (askingStrat.getName().indexOf("Coalition")>=0) {
                    continue;
                }
                AskingStrategy newStrat1 = (AskingStrategy)askingStrat.getClass().newInstance();

                newStrat1.setName(askingStrat.getName());
                
                newStrat1.setMemory(0);
                newStrat1.setNegative(false);
                l12.add(newStrat1);
            }catch(InstantiationException e) {
                System.out.println(e.toString());
            }catch(IllegalAccessException e) {
                System.out.println(e.toString());
            }
        }
        
        it = l3.iterator();
        
        while (it.hasNext()) {
            try {
                DecisionSupportStrategy decisionStrat = (DecisionSupportStrategy)it.next();
                if (decisionStrat.getName().indexOf("Coalition")>=0) {
                    continue;
                }                
                DecisionSupportStrategy newStrat1 = (DecisionSupportStrategy)decisionStrat.getClass().newInstance();

                newStrat1.setName(decisionStrat.getName());
                
                newStrat1.setMemory(0);
                newStrat1.setNegative(false);
                l13.add(newStrat1);
            }catch(InstantiationException e) {
                System.out.println(e.toString());
            }catch(IllegalAccessException e) {
                System.out.println(e.toString());
            }
        }
        int nbComb = l11.size()*l12.size()*l13.size();
        System.out.println("attack = "+l11.size());
        System.out.println("asking = "+l12.size());
        System.out.println("decision = "+l13.size());
        System.out.println("nbComb = "+nbComb);
        for(int i=0;i<l11.size();i++) {
            AttackStrategy attackStrat = (AttackStrategy)l11.get(i);
            for(int j=0;j<l12.size();j++) {
                AskingStrategy askingStrat = (AskingStrategy)l12.get(j);
                for(int k=0;k<l13.size();k++) {
                    DecisionSupportStrategy decisionStrat = (DecisionSupportStrategy)l13.get(k);
                    GenericComposedStrategy completeStrat = new GenericComposedStrategy();
                    completeStrat.getAskingStrategyVector().add(askingStrat);
                    completeStrat.getAttackStrategyVector().add(attackStrat);
                    AttackRandomlyStrategy randomStrat = new AttackRandomlyStrategy();
                    completeStrat.getAttackStrategyVector().add(randomStrat);
                    completeStrat.getDecisionStrategyVector().add(decisionStrat);
                    completeStrat.setName(getEasyName(completeStrat));
                    strategyList.add(completeStrat);
                }
            }
        }
        System.out.println("strategyList.size() = "+strategyList.size());
        
        int cptGame = 0;
        int cptStrat = 0;
        int currentSerie = 1;
        for(int j=0;j<100;j++) {
            ArrayList playersList = new ArrayList();
            for(int i=0;i<strategyList.size();i++) {
                GenericComposedStrategy strat = (GenericComposedStrategy)strategyList.get(i);
                Player p = new Player("Player #"+i+"("+strat.getName()+")",hp,strat);
                playersList.add(p);
            }
            try {
                File f = new File(rootFolderTextField.getText()+"/serie"+j+
                "/xmlGameFiles/game1.xml");
                XMLGameWriter gameWriter = new XMLGameWriter();
                gameWriter.create(f,j, 1, 1, 0, 0, coalDef, false,
                new File("../history/history1.txt"),
                new File("../graph/graph1.png"),
                playersList);
                File scriptFile = new File(rootFolderTextField.getText()+
                "/serie"+j+"/scripts/script1.sh");
                FileWriter writer = new FileWriter(scriptFile);
                writer.write("#!/bin/sh\n\n");
                writer.write("echo \"Launching game #1 on 1\"\n");
                writer.write("java -jar ../../simulations.jar "+
                "../xmlGameFiles/game1.xml -noHistory\n\n");
                writer.close();
                try {
                    Runtime runTime=Runtime.getRuntime();
                    Process process=runTime.exec("chmod +x "+rootFolderTextField.getText()+
                    "/serie"+j+"/scripts/script1.sh");
                }catch(IOException e) {
                    System.out.println(e.toString());
                }
           }catch(IOException e) {
                System.out.println(e.toString());
                return;
            }
        }
        try {
            File scriptFile = new File(rootFolderTextField.getText()+
            "/script.sh");
            FileWriter writer = new FileWriter(scriptFile);
            writer.write("#!/bin/sh\n\n");
            for(int i = 0;i<100;i++) {
                writer.write("echo \"Launching game #"+i+" on 100\"\n");
                writer.write("cd ~/tests2/serie"+i+"/scripts \n");
                writer.write("./script1.sh\n\n");
            }
            writer.close();
        }catch(IOException e) {
            System.out.println(e.toString());
            return;
        }
    }
    
    public String getEasyName(GenericComposedStrategy strat) {
        Vector attVector = strat.getAttackStrategyVector();
        Vector askVector = strat.getAskingStrategyVector();
        Vector decVector = strat.getDecisionStrategyVector();
        String str;
        str = ((AttackStrategy)attVector.get(0)).getAbr()+"-"+
        ((AskingStrategy)askVector.get(0)).getAbr()+"-"+
        ((DecisionSupportStrategy)decVector.get(0)).getAbr();
        return str;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        rootFolderTextField = new javax.swing.JTextField();
        rootFolderButton = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        randomSeedSpinner = new javax.swing.JSpinner();
        jLabel4 = new javax.swing.JLabel();
        playersHPTextField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        nbPlayersSpinner = new javax.swing.JSpinner();
        jLabel6 = new javax.swing.JLabel();
        coalDef1RadioButton = new javax.swing.JRadioButton();
        coalDef2RadioButton = new javax.swing.JRadioButton();
        coalDef3RadioButton = new javax.swing.JRadioButton();
        coalDef4RadioButton = new javax.swing.JRadioButton();
        coalDef5RadioButton = new javax.swing.JRadioButton();
        jLabel7 = new javax.swing.JLabel();
        nbScriptsTextField = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jarFileTextField = new javax.swing.JTextField();
        jarFileButton = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        saveButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jLabel1.setFont(new java.awt.Font("Dialog", 1, 18));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Create test 288");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Root folder : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel2, gridBagConstraints);

        rootFolderTextField.setColumns(25);
        rootFolderTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        jPanel2.add(rootFolderTextField, gridBagConstraints);

        rootFolderButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        rootFolderButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        rootFolderButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rootFolderButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        jPanel2.add(rootFolderButton, gridBagConstraints);

        jLabel3.setText("Random seed : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(randomSeedSpinner, gridBagConstraints);

        jLabel4.setText("Players HP : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel4, gridBagConstraints);

        playersHPTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        playersHPTextField.setText("50");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(playersHPTextField, gridBagConstraints);

        jLabel5.setText("Nb players : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel5, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(nbPlayersSpinner, gridBagConstraints);

        jLabel6.setText("Coalition def : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(jLabel6, gridBagConstraints);

        coalDef1RadioButton.setSelected(true);
        coalDef1RadioButton.setText("1");
        buttonGroup1.add(coalDef1RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef1RadioButton, gridBagConstraints);

        coalDef2RadioButton.setText("2");
        buttonGroup1.add(coalDef2RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef2RadioButton, gridBagConstraints);

        coalDef3RadioButton.setText("3");
        buttonGroup1.add(coalDef3RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef3RadioButton, gridBagConstraints);

        coalDef4RadioButton.setText("4");
        buttonGroup1.add(coalDef4RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef4RadioButton, gridBagConstraints);

        coalDef5RadioButton.setText("5");
        buttonGroup1.add(coalDef5RadioButton);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(coalDef5RadioButton, gridBagConstraints);

        jLabel7.setText("Nb scripts : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        jPanel2.add(jLabel7, gridBagConstraints);

        nbScriptsTextField.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        nbScriptsTextField.setText("20");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 9;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        jPanel2.add(nbScriptsTextField, gridBagConstraints);

        jLabel8.setText("Jar file : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 10;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel8, gridBagConstraints);

        jarFileTextField.setColumns(25);
        jarFileTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 10;
        jPanel2.add(jarFileTextField, gridBagConstraints);

        jarFileButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        jarFileButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jarFileButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jarFileButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 10;
        jPanel2.add(jarFileButton, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/save.png")));
        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        jPanel1.add(saveButton);

        closeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // TODO add your handling code here:
        this.setVisible(false);
        this.dispose();
    }//GEN-LAST:event_closeButtonActionPerformed

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        // TODO add your handling code here:
        init();
    }//GEN-LAST:event_saveButtonActionPerformed

    private void jarFileButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jarFileButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        StrategyFileFilter filter = new StrategyFileFilter();
        filter.addExtension("jar");
        filter.setDescription("Jar file");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            String fileName = chooser.getSelectedFile().getPath();
            try {
                System.out.println(fileName);
            }catch(IndexOutOfBoundsException e) {
            }
            jarFile=new File(fileName);
            jarFileTextField.setText(fileName);
        }
    }//GEN-LAST:event_jarFileButtonActionPerformed

    private void rootFolderButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rootFolderButtonActionPerformed
        // TODO add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            rootFolderTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_rootFolderButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton closeButton;
    private javax.swing.JRadioButton coalDef1RadioButton;
    private javax.swing.JRadioButton coalDef2RadioButton;
    private javax.swing.JRadioButton coalDef3RadioButton;
    private javax.swing.JRadioButton coalDef4RadioButton;
    private javax.swing.JRadioButton coalDef5RadioButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton jarFileButton;
    private javax.swing.JTextField jarFileTextField;
    private javax.swing.JSpinner nbPlayersSpinner;
    private javax.swing.JTextField nbScriptsTextField;
    private javax.swing.JTextField playersHPTextField;
    private javax.swing.JSpinner randomSeedSpinner;
    private javax.swing.JButton rootFolderButton;
    private javax.swing.JTextField rootFolderTextField;
    private javax.swing.JButton saveButton;
    // End of variables declaration//GEN-END:variables
    
}
