/*
 * EditHTMLPlayersStrategyDialog.java
 *
 * Created on 1 juin 2004, 02:58
 */

package simulations.gui;

import java.io.File;
import java.io.FileWriter;
import java.io.FileReader;
import java.io.IOException;

import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.JFileChooser;

/**
 *
 * @author  tom
 */
public class EditHTMLPlayersStrategyDialog extends javax.swing.JDialog {
    
    /** Creates new form EditHTMLPlayersStrategyDialog */
    public EditHTMLPlayersStrategyDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }
    
    public void generate() {
        FileWriter writer = null;
        try {
            writer = new FileWriter(new File(destinationFolderTextField.getText()+"/strategies.txt"));
        }catch(IOException e) {
            System.out.println(e.toString());
            return;
        }
        File fRoot = new File(sourceFolderTextField.getText());
        File[] fList = fRoot.listFiles();
        ArrayList folderList = new ArrayList();
        for(int i=0;i<fList.length;i++) {
            File f = (File)fList[i];
            if (f.isDirectory()) {
                if (f.getName().indexOf("serie")==0) {
                    if (f.getName().indexOf("/")<0) {
                        folderList.add(f);
                    }
                }
            }
        }
        Iterator it = folderList.iterator();
        while (it.hasNext()) {
            File f = (File)it.next();
            File historyFileFolder = new File(f.getPath()+"/history");
            File[] historyFolder = historyFileFolder.listFiles();
            for(int i=0;i<historyFolder.length;i++) {
                File historyFile = historyFolder[i];
                if (historyFile.getPath().substring(historyFile.getPath().length()-4,historyFile.getPath().length()).equals(".txt")) {
                    if (historyFile.getName().indexOf("history")==0) {
                        if (historyFile.getName().indexOf("summary")<0) {
                            try {
                                System.out.println("read "+historyFile.getPath());
                                FileReader reader = new FileReader(historyFile);
                                // go to line 2
                                nextLine(reader);
                                String s = nextLine(reader);
                                while ((s.indexOf('-')>0)||(s.indexOf('-')<0)) {
                                    writer.write(s);
                                    s = nextLine(reader);
                                }
                                reader.close();
                            }catch(IOException e) {
                                System.out.println(e.toString());
                                return;
                            }
                        }
                    }
                }
            }
        }
        try {
            writer.close();
        }catch(IOException e) {
            System.out.println(e.toString());
            return;
        }    
    }
    
    /** Return the next line of the history file
     * @throws IOException Return an IOException in case of problem
     * @return Return the next line of the history file
     */    
    public String nextLine(FileReader reader) throws IOException {
        String s="";
        try {
            int c;
            char ch;
            while ((c=reader.read())>=0) {
                ch=(char)c;
                s=s.concat(s.valueOf(ch));
                if (ch=='\n') {
                    break;
                }
            }
        }catch(IOException e) {
            throw e;
        }
        return s;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        sourceFolderTextField = new javax.swing.JTextField();
        sourceFolderButton = new javax.swing.JButton();
        destinationFolderTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        destinationFolderButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        saveButton = new javax.swing.JButton();
        closeButton = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Source folder : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel2, gridBagConstraints);

        sourceFolderTextField.setColumns(15);
        sourceFolderTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(sourceFolderTextField, gridBagConstraints);

        sourceFolderButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        sourceFolderButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sourceFolderButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(sourceFolderButton, gridBagConstraints);

        destinationFolderTextField.setColumns(15);
        destinationFolderTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(destinationFolderTextField, gridBagConstraints);

        jLabel3.setText("Destination folder : ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(jLabel3, gridBagConstraints);

        destinationFolderButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/folder.png")));
        destinationFolderButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                destinationFolderButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel2.add(destinationFolderButton, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Edit HTML player's strategies");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        saveButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/save.png")));
        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveButtonActionPerformed(evt);
            }
        });

        jPanel1.add(saveButton);

        closeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void saveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveButtonActionPerformed
        // Add your handling code here:
        generate();
    }//GEN-LAST:event_saveButtonActionPerformed

    private void destinationFolderButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_destinationFolderButtonActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            destinationFolderTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_destinationFolderButtonActionPerformed

    private void sourceFolderButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sourceFolderButtonActionPerformed
        // Add your handling code here:
        JFileChooser chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        int returnVal = chooser.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            if (simulations.SimulationParameters.debug) {
                System.out.println("You chose to save this file: " +
                chooser.getSelectedFile().getName());
            }
            sourceFolderTextField.setText(chooser.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_sourceFolderButtonActionPerformed

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
        
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton closeButton;
    private javax.swing.JButton destinationFolderButton;
    private javax.swing.JTextField destinationFolderTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JButton saveButton;
    private javax.swing.JButton sourceFolderButton;
    private javax.swing.JTextField sourceFolderTextField;
    // End of variables declaration//GEN-END:variables
    
}
