/*
 * MsgBox.java
 *
 * Created on 20 janvier 2004, 23:21
 */

package simulations.gui;

/** This class is a generic message box
 * @author tom
 */
public class MsgBox extends javax.swing.JDialog {
    
    private boolean ok;
    
    /** Creates new form MsgBox
     * @param yesNo If true, the dialog will display two buttons (Yes and No) else the dialog will
     * just display one button Ok
     * @param parent The parent frame
     * @param modal true if it's a modal dialog
     * @param line1 The first line of the message
     * @param line2 The second line of the message
     */
    public MsgBox(java.awt.Frame parent, boolean modal, String line1, String line2,boolean yesNo) {
        super(parent, modal);
        ok=false;
        initComponents();
        label1.setText(line1);
        label2.setText(line2);
        if (yesNo) {
            javax.swing.JButton noButton = new javax.swing.JButton("No");
            noButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
            noButton.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent evt) {
                    noButtonActionPerformed(evt);
                }
            });
            okButton.setText("Yes");
            buttonsPanel.add(noButton);
        }
        this.setLocationRelativeTo(parent);
        this.setSize(250,150);
    }
        
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        buttonsPanel = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        centerPanel = new javax.swing.JPanel();
        label1 = new javax.swing.JLabel();
        label2 = new javax.swing.JLabel();

        setTitle("Message");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/apply.png")));
        okButton.setText("OK");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        buttonsPanel.add(okButton);

        getContentPane().add(buttonsPanel, java.awt.BorderLayout.SOUTH);

        centerPanel.setLayout(new java.awt.GridLayout(0, 1));

        label1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        centerPanel.add(label1);

        label2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        centerPanel.add(label2);

        getContentPane().add(centerPanel, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        // Add your handling code here:
        ok=true;
        closeDialog(null);
    }//GEN-LAST:event_okButtonActionPerformed
     
    private void noButtonActionPerformed(java.awt.event.ActionEvent evt) {
        // Add your handling code here:
        ok=false;
        closeDialog(null);
    }
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    /** Getter for property ok.
     * @return Value of property ok.
     *
     */
    public boolean isOk() {
        return ok;
    }    
    
    /** Setter for property ok.
     * @param ok New value of property ok.
     *
     */
    public void setOk(boolean ok) {
        this.ok = ok;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel buttonsPanel;
    private javax.swing.JPanel centerPanel;
    private javax.swing.JLabel label1;
    private javax.swing.JLabel label2;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables
    
}
