/*
 * StatisticsDialog.java
 *
 * Created on April 13, 2004, 11:59 PM
 */

package simulations.gui;

import java.util.ArrayList;
import java.util.Iterator;

import simulations.core.history.PlayerStatElement;
import simulations.core.history.PlayersStats;
import simulations.core.Player;

/**
 * This class describes the dialog box to view the statistics
 * @author  tom
 */
public class StatisticsDialog extends javax.swing.JDialog {
    
    /** The statistics list to display **/
    private ArrayList statisticsList;
    
    /** Creates new form StatisticsDialog
     * @param parent The parent frame
     * @param modal true if the dialog is modal
     * @param l The statistics list
     */
    public StatisticsDialog(java.awt.Frame parent, boolean modal, ArrayList l) {
        super(parent, modal);
        initComponents();
        statisticsList=l;
        initPlayerList();
        this.setSize(600,400);
    }
    
    /** Init the combo box players list **/
    private void initPlayerList() {
        Iterator it = statisticsList.iterator();
        while (it.hasNext()) {
            PlayersStats ps = (PlayersStats)it.next();
            playerComboBox.addItem(ps.getPlayer());
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        closeButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        playerComboBox = new javax.swing.JComboBox();
        strategyLabel = new javax.swing.JLabel();
        jScrollPane4 = new javax.swing.JScrollPane();
        strategyTextArea = new javax.swing.JTextArea();
        tabbedPane = new javax.swing.JTabbedPane();
        panelAttacked = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        attackedPlayersJList = new javax.swing.JList();
        panelAsking = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        askedPlayersJList = new javax.swing.JList();
        panelSupported = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        supportedAttacksJList = new javax.swing.JList();

        setTitle("Statistics");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 16));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Statistics");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        closeButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/simulations/icons/button_cancel.png")));
        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });

        jPanel1.add(closeButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.BorderLayout());

        jLabel2.setText("Player ");
        jPanel3.add(jLabel2);

        playerComboBox.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                playerComboBoxItemStateChanged(evt);
            }
        });

        jPanel3.add(playerComboBox);

        strategyLabel.setText("jLabel3");
        jPanel3.add(strategyLabel);

        jScrollPane4.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
        strategyTextArea.setColumns(25);
        strategyTextArea.setEditable(false);
        strategyTextArea.setLineWrap(true);
        strategyTextArea.setRows(3);
        strategyTextArea.setWrapStyleWord(true);
        jScrollPane4.setViewportView(strategyTextArea);

        jPanel3.add(jScrollPane4);

        jPanel2.add(jPanel3, java.awt.BorderLayout.NORTH);

        panelAttacked.setLayout(new java.awt.BorderLayout());

        jLabel3.setText("This list contains the players that have been attacked and many times");
        jPanel4.add(jLabel3);

        panelAttacked.add(jPanel4, java.awt.BorderLayout.NORTH);

        jScrollPane1.setViewportView(attackedPlayersJList);

        panelAttacked.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        tabbedPane.addTab("Attacked Players", panelAttacked);

        panelAsking.setLayout(new java.awt.BorderLayout());

        jLabel4.setText("This list contains the players that he ask support and many times");
        jPanel5.add(jLabel4);

        panelAsking.add(jPanel5, java.awt.BorderLayout.NORTH);

        jScrollPane2.setViewportView(askedPlayersJList);

        panelAsking.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        tabbedPane.addTab("Asked players", panelAsking);

        panelSupported.setLayout(new java.awt.BorderLayout());

        jLabel5.setText("This list contains the players that have been supported attacks and many times");
        jPanel6.add(jLabel5);

        panelSupported.add(jPanel6, java.awt.BorderLayout.NORTH);

        jScrollPane3.setViewportView(supportedAttacksJList);

        panelSupported.add(jScrollPane3, java.awt.BorderLayout.CENTER);

        tabbedPane.addTab("Supported attacks", panelSupported);

        jPanel2.add(tabbedPane, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    /** This method returns the PlayersStats element of a player of the statistics list
     * @param p The player 
     * @return returns the PlayersStats element of a player of the statistics list
     **/
    private PlayersStats getPlayersStats(Player p) {
        Iterator it = statisticsList.iterator();
        while (it.hasNext()) {
            PlayersStats ps = (PlayersStats)it.next();
            if (ps.getPlayer().equals(p)) {
                return ps;
            }
        }
        return null;
    }
    
    private void playerComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_playerComboBoxItemStateChanged
        // Add your handling code here:
        if (playerComboBox.getSelectedItem()!=null) {
            Player p = (Player)playerComboBox.getSelectedItem();
            strategyLabel.setText(p.getStrategy().toString());
            strategyTextArea.setText(p.getStrategy().getDescription());
            PlayersStats ps = getPlayersStats(p);
            Iterator it = ps.getAttackedStatsList().iterator();
            ArrayList l1 = new ArrayList();
            while (it.hasNext()) {
                l1.add(it.next());
            }
            it = ps.getAskingStatsList().iterator();
            ArrayList l2 = new ArrayList();
            while (it.hasNext()) {
                l2.add(it.next());
            }
            it = ps.getSupportsStatsList().iterator();
            ArrayList l3 = new ArrayList();
            while (it.hasNext()) {
                l3.add(it.next());
            }
            attackedPlayersJList.setListData(l1.toArray());
            askedPlayersJList.setListData(l2.toArray());
            supportedAttacksJList.setListData(l3.toArray());
        }
    }//GEN-LAST:event_playerComboBoxItemStateChanged

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JList askedPlayersJList;
    private javax.swing.JList attackedPlayersJList;
    private javax.swing.JButton closeButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JPanel panelAsking;
    private javax.swing.JPanel panelAttacked;
    private javax.swing.JPanel panelSupported;
    private javax.swing.JComboBox playerComboBox;
    private javax.swing.JLabel strategyLabel;
    private javax.swing.JTextArea strategyTextArea;
    private javax.swing.JList supportedAttacksJList;
    private javax.swing.JTabbedPane tabbedPane;
    // End of variables declaration//GEN-END:variables
    
}
